23b40159d584bda35ac65aac1608cf10957dd2e6
[grml-autoconfig.git] / autoconfig.functions
1 #!/bin/zsh
2 # Filename:      autoconfig.functions
3 # Purpose:       basic system configuration and hardware setup for grml system
4 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2.
7 ################################################################################
8
9 # {{{ path, variables, signals, umask, zsh
10 export PATH="/bin:/sbin:/usr/bin:/usr/sbin:/usr/X11R6/bin"
11 DEBUG="/dev/null"
12 KERNEL="$(uname -r)"
13 ARCH="$(uname -m)"
14 umask 022
15
16 # old linuxrc version:
17 [ -d /cdrom ]      && export LIVECD_PATH=/cdrom
18 # new initramfs layout:
19 [ -d /live/image ] && export LIVECD_PATH=/live/image
20
21 # Ignore these signals in non-interactive mode: INT, TERM, SEGV
22 [ -z "$PS1" ] && trap "" 2 3 11
23
24 # zsh stuff
25 iszsh(){
26 if [ -n "$ZSH_VERSION" ] ; then
27   return 0
28 else
29   return 1
30 fi
31 }
32 # avoid 'no matches found: ...'
33 iszsh && setopt no_nomatch # || echo "Warning: not running under zsh!"
34 # }}}
35
36 # {{{ Read in boot parameters
37 if [ -z "$CMDLINE" ]; then
38   # if CMDLINE was set from the outside, we're debugging.
39   # otherwise, take CMDLINE from Kernel and config files.
40   CMDLINE="$(cat /proc/cmdline)"
41   [ -d /cdrom/bootparams/ ]      && CMDLINE="$CMDLINE $(cat /cdrom/bootparams/* | tr '\n' ' ')"
42   [ -d /live/image/bootparams/ ] && CMDLINE="$CMDLINE $(cat /live/image/bootparams/* | tr '\n' ' ')"
43 fi
44 # }}}
45
46 ### {{{ Utility Functions
47
48 # Get a bootoption's parameter: read boot command line and either
49 # echo last parameter's argument or return false.
50 getbootparam(){
51   local line
52   local ws
53   ws='   '
54   line=" $CMDLINE "
55   case "$line" in
56     *[${ws}]"$1="*)
57       result="${line##*[$ws]$1=}"
58       result="${result%%[$ws]*}"
59       echo "$result"
60       return 0 ;;
61     *) # no match?
62       return 1 ;;
63   esac
64 }
65
66 # Check boot commandline for specified option
67 checkbootparam(){
68   [ -n "$1" ] || ( echo "Error: missing argument to checkbootparam()" ; return 1 )
69   local line
70   local ws
71   ws='   '
72   line=" $CMDLINE "
73   case "$line" in
74     *[${ws}]"$1"=*|*[${ws}]"$1"[${ws}]*)
75       return 0 ;;
76     *)
77       return 1 ;;
78   esac
79 }
80
81 # Check if currently using a framebuffer
82 hasfb() {
83     [ -e /dev/fb0 ] && return 0 || return 1
84 }
85
86 # Check wheter a configuration variable (like $CONFIG_TOHD) is
87 # enabled or not
88 checkvalue(){
89   case "$1" in
90     [yY][eE][sS])     return 0 ;; # it's set to 'yes'
91     [tT][rR][uU][eE]) return 0 ;; # it's set to 'true'
92                    *) return 1 ;; # default
93   esac
94 }
95
96 # Are we using grml-small?
97 checkgrmlsmall(){
98   grep -q small /etc/grml_version 2>>$DEBUG && return 0 || return 1
99 }
100
101 # execute flite only if it's present
102 flitewrapper() {
103    [ -x /usr/bin/flite ] && flite -o play -t "$*"
104 }
105 ### }}}
106
107 # {{{ filesystems (proc, pts, sys) and fixes
108 mount_proc(){
109   [ -f /proc/version ] || mount -t proc /proc /proc 2>/dev/null
110 }
111
112 mount_pts(){
113   grep -q "/dev/pts" /proc/mounts || mount -t devpts /dev/pts /dev/pts 2>/dev/null
114 }
115
116 mount_sys(){
117   [ -d /sys/devices ] || mount -t sysfs /sys /sys 2>/dev/null
118 }
119 # }}}
120
121 # {{{ Check if we are running in live mode or from HD
122 INSTALLED=""
123 [ -e /etc/grml_cd ] || INSTALLED="yes"
124
125 # testcd
126 TESTCD=""
127 checkbootparam 'testcd' >>$DEBUG 2>&1 && TESTCD="yes"
128 # }}}
129
130 # {{{ source lsb-functions , color handling
131 if checkbootparam 'nocolor'; then
132   RC_NOCOLOR=yes
133   . /etc/grml/lsb-functions
134   einfo "Disabling colors in bootsequence as requested on commandline." ; eend 0
135 else
136   . /etc/grml/lsb-functions
137   . /etc/grml_colors
138 fi
139 # }}}
140
141 # {{{ debug
142 config_debug(){
143  checkbootparam 'debug'            && BOOTDEBUG="yes"
144  checkbootparam "BOOT_IMAGE=debug" && BOOTDEBUG="yes"
145
146  rundebugshell(){
147   if [ -n "$BOOTDEBUG" ]; then
148      einfo "Starting intermediate shell stage $stage as requested by \"debug\" option."
149      if [ grep -q "debug=noscreen" "$CMDLINE" ] ; then
150         einfo "Notice that the shell does not provide job handling: ctrl-z, bg and fg won't work!"
151         einfo "Just exit the shell to continue boot process..."
152         /bin/zsh
153      else
154         eindent
155         if [ -r /etc/grml/screenrc ] ; then
156            einfo "Starting GNU screen to be able to use a full featured shell environment."
157            einfo "Just exit the shells (and therefore screen) to continue boot process..."
158            /bin/zsh -c "screen -c /etc/grml/screenrc"
159         else
160            einfo "Notice that the shell does not provide job handling: ctrl-z, bg and fg won't work!"
161            einfo "Just exit the shell to continue boot process..."
162            /bin/zsh
163         fi
164         eoutdent
165      fi
166   fi
167  }
168 }
169 # }}}
170
171 # {{{ log
172 config_log(){
173 if checkbootparam 'log' || checkbootparam 'debug' ; then
174    export DEBUG="/tmp/grml.log.`date +%Y%m%d`"
175    touch $DEBUG
176    einfo "Bootparameter log found. Log files: ${DEBUG} and /var/log/boot"
177    eindent
178      einfo "Starting bootlogd." # known to be *very* unreliable :(
179      bootlogd -r -c >>$DEBUG 2>&1 ; eend $?
180    eoutdent
181 else
182    DEBUG="/dev/null"
183 fi
184 }
185 # }}}
186
187 # {{{ set firmware timeout via bootparam
188 config_fwtimeout(){
189  if checkbootparam 'fwtimeout' ; then
190    TIMEOUT="$(getbootparam 'fwtimeout' 2>>$DEBUG)"
191    einfo "Bootoption fwtimeout found. (Re)Loading firmware_class module."
192    rmmod firmware_class >>$DEBUG 2>&1
193    modprobe firmware_class ; eend $?
194  fi
195  if [ -z "$TIMEOUT" ] ; then
196    TIMEOUT="100" # linux kernel default: 10
197  fi
198  if [ -f /sys/class/firmware/timeout ] ; then
199    einfo "Setting timeout for firmware loading to ${TIMEOUT}."
200    echo 100 > /sys/class/firmware/timeout ; eend $?
201  fi
202 }
203 # }}}
204
205 ### {{{ language configuration / localization
206 config_language(){
207
208  einfo "Activating language settings:"
209  eindent
210
211  # people can specify $LANGUAGE and $CONSOLEFONT in a config file
212  [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
213
214  # check for bootoption which overrides config from /etc/grml/autoconfig
215  BOOT_LANGUAGE="$(getbootparam 'lang' 2>>$DEBUG)"
216  [ -n "$BOOT_LANGUAGE" ] && LANGUAGE="$BOOT_LANGUAGE"
217
218  # set default to 'en' in live-cd mode iff $LANGUAGE is not set yet
219  if [ -z "$INSTALLED" ] ; then
220     [ -n "$LANGUAGE" ] || LANGUAGE='en'
221  fi
222
223  if [ -x /usr/sbin/grml-setlang ] ; then
224    # if bootoption lang is used update /etc/default/locale accordingly
225    if [ -n "$BOOT_LANGUAGE" ] ; then
226      checkgrmlsmall && /usr/sbin/grml-setlang "POSIX" || /usr/sbin/grml-setlang "$LANGUAGE"
227    # otherwise default to lang=en
228    else
229      checkgrmlsmall && /usr/sbin/grml-setlang "POSIX" || /usr/sbin/grml-setlang "en"
230    fi
231  fi
232
233  # set console font
234  if [ -z "$CONSOLEFONT" ] ; then
235     if ! checkbootparam 'nodefaultfont' >>$DEBUG 2>&1 ; then
236        if [ -r /usr/share/consolefonts/Uni3-Terminus16.psf.gz ] ; then
237           CONSOLEFONT='Uni3-Terminus16'
238        else
239           ewarn "/usr/share/consolefonts/Uni3-Terminus16.psf.gz not available. Please upgrade package console-terminus." ; eend 1
240        fi
241        if ! hasfb ; then
242           CONSOLEFONT='Lat15-Terminus16'
243        fi
244     fi
245  fi
246
247  # export it now, so error messages get translated, too
248  if checkgrmlsmall ; then
249     export LANG='C' # grml-small does not provide any further locales
250  else
251     [ -r /etc/default/locale ] && . /etc/default/locale
252     export LANG LANGUAGE
253  fi
254
255  # configure keyboard layout, read in already set values first:
256  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
257
258  # now allow keyboard override by boot commandline for later use:
259  KKEYBOARD="$(getbootparam 'keyboard' 2>>$DEBUG)"
260  [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
261  # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
262  [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
263  [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
264
265  # modify /etc/sysconfig/keyboard only in live-cd mode:
266  if [ -z "$INSTALLED" ] ; then
267
268    local LANGUAGE="$BOOT_LANGUAGE"
269    . /etc/grml/language-functions
270    # allow setting xkeyboard explicitly different than console keyboard
271    KXKEYBOARD="$(getbootparam 'xkeyboard' 2>>$DEBUG)"
272    if [ -n "$KXKEYBOARD" ]; then
273       XKEYBOARD="$KXKEYBOARD"
274       KDEKEYBOARD="$KXKEYBOARD"
275    elif [ -n "$KKEYBOARD" ]; then
276       XKEYBOARD="$KKEYBOARD"
277       KDEKEYBOARD="$KKEYBOARD"
278    fi
279
280    # duplicate of previous code to make sure /etc/grml/language-functions
281    # does not overwrite our values....
282    # now allow keyboard override by boot commandline for later use:
283    KKEYBOARD="$(getbootparam 'keyboard' 2>>$DEBUG)"
284    [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
285    # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
286    [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
287    [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
288
289    # write keyboard related variables to file for later use
290    [ -d /etc/sysconfig ] || mkdir /etc/sysconfig
291    if ! [ -e /etc/sysconfig/keyboard ] ; then
292       echo "KEYTABLE=\"$KEYTABLE\""          > /etc/sysconfig/keyboard
293       echo "XKEYBOARD=\"$XKEYBOARD\""       >> /etc/sysconfig/keyboard
294       echo "KDEKEYBOARD=\"$KDEKEYBOARD\""   >> /etc/sysconfig/keyboard
295       echo "KDEKEYBOARDS=\"$KDEKEYBOARDS\"" >> /etc/sysconfig/keyboard
296    fi
297  fi
298
299  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
300
301  # activate unicode console if running within utf8 environment
302  if [ -r /etc/default/locale ] ; then
303     if grep -q "LANG=.*UTF" /etc/default/locale ; then
304        einfo "Setting up unicode environment."
305        unicode_start >>$DEBUG 2>&1 ; eend $?
306     fi
307  fi
308
309  # Set default keyboard before interactive setup
310  if [ -n "$KEYTABLE" ] ; then
311     einfo "Running loadkeys for ${WHITE}${KEYTABLE}${NORMAL} in background"
312     loadkeys -q $KEYTABLE &
313     eend $?
314  fi
315
316  # we have to set up all consoles, therefore loop it over all ttys:
317  NUM_CONSOLES=$(fgconsole --next-available 2>/dev/null)
318  if [ -n "$NUM_CONSOLES" ] ; then
319     NUM_CONSOLES=$(expr ${NUM_CONSOLES} - 1)
320     [ ${NUM_CONSOLES} -eq 1 ] && NUM_CONSOLES=6
321  fi
322  CUR_CONSOLE=$(fgconsole 2>/dev/null)
323
324  if [ -x "$(which setfont)" ] ; then
325     use_setfont=true
326  elif [ -x "$(which consolechars)" ] ; then
327     use_consolechars=true
328  else
329     eerror "Neither setfont nor consolechars tool present, can not set font."
330     eend 1
331     return 1
332  fi
333
334  if [ -n "$CHARMAP" ] ; then
335     einfo "Setting font to ${CHARMAP}"
336     RC=0
337     for vc in $(seq 0 ${NUM_CONSOLES}) ; do
338         if $use_setfont ; then
339           setfont -C /dev/tty${vc} $CHARMAP ; RC=$?
340         elif $use_consolechars ; then
341           consolechars --tty=/dev/tty${vc} -m ${CHARMAP} ; RC=$?
342         fi
343     done
344     if [ -n "$CUR_CONSOLE" ] ; then
345        [ "$CUR_CONSOLE" != "serial" ] && chvt $CUR_CONSOLE
346     fi
347     eend $RC
348  fi
349
350  if checkbootparam 'noconsolefont' ; then
351     ewarn "Skipping setting console font as requested on boot commandline." ; eend 0
352  else
353     if [ -n "$CONSOLEFONT" ] ; then
354        einfo "Setting font to ${CONSOLEFONT}"
355        RC=0
356        for vc in $(seq 0 ${NUM_CONSOLES}) ; do
357            if $use_setfont ; then
358              setfont -C /dev/tty${vc} ${CONSOLEFONT} ; RC=$?
359            elif $use_consolechars ; then
360              consolechars --tty=/dev/tty${vc} -f ${CONSOLEFONT} ; RC=$?
361            fi
362        done
363        if [ -n "$CUR_CONSOLE" ] ; then
364           [ "$CUR_CONSOLE" != "serial" ] && chvt $CUR_CONSOLE
365        fi
366        eend $RC
367     fi
368  fi
369
370  eoutdent
371 }
372 # }}}
373
374 # {{{ Set hostname
375 config_hostname(){
376  if checkbootparam 'hostname' ; then
377   HOSTNAME="$(getbootparam 'hostname' 2>>$DEBUG)"
378   if [ -z "$HOSTNAME" ] && [ -x /usr/bin/random-hostname ] ; then
379      einfo "Generating random hostname as no hostname was specified."
380      HOSTNAME="$(/usr/bin/random-hostname)"
381      eend $?
382   fi
383   einfo "Setting hostname to $HOSTNAME as requested."
384   grml-hostname $HOSTNAME >>$DEBUG ; RC=$?
385   [ "$RC" = "0" ] && hostname $HOSTNAME
386   eend $RC
387  else
388   hostname --file /etc/hostname
389  fi
390 }
391 # }}}
392
393 # fstabuser (needed when running from harddisk with username != grml {{{
394 config_userfstab(){
395   [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
396   if [ -n "$CONFIG_FSTAB_USER" ] ; then
397      fstabuser="$CONFIG_FSTAB_USER"
398   else
399      fstabuser=$(getent passwd 1000 | cut -d: -f1)
400   fi
401   # if not yet set fall back to default 'grml' user
402   [ -n "$fstabuser" ] || fstabuser='grml'
403 }
404 # }}}
405
406 # {{{ Set clock (Local time is more often used than GMT, so it is default)
407 config_time(){
408  # don't touch the files if running from harddisk:
409  if [ -z "$INSTALLED" ]; then
410     # The default hardware clock timezone is stated as representing local time.
411     UTC="--localtime"
412     grep -q "^UTC=" /etc/default/rcS || echo "UTC=no" >> /etc/default/rcS
413     checkbootparam 'utc'       >>$DEBUG 2>&1 && sed -i "s|^UTC=.*$|UTC=yes|" /etc/default/rcS
414     checkbootparam 'gmt'       >>$DEBUG 2>&1 && sed -i "s|^UTC=.*$|UTC=yes|" /etc/default/rcS
415     checkbootparam 'localtime' >>$DEBUG 2>&1 && sed -i "s|^UTC=.*$|UTC=no|"  /etc/default/rcS
416     grep -q -i "^UTC=yes" /etc/default/rcS && UTC="-u"
417     # hwclock uses the TZ variable
418     KTZ="$(getbootparam 'tz' 2>>$DEBUG)"
419     [ -z "$KTZ" ] && [ -r /etc/timezone ] && KTZ=$(cat /etc/timezone)
420     if [ ! -f "/usr/share/zoneinfo/$KTZ" ] ; then
421        ewarn "Warning: unknown timezone $KTZ" ; eend 1
422        KTZ="Europe/Vienna"
423        ewarn "Falling back to timezone $KTZ" ; eend 0
424     fi
425
426     if ! [ -r /dev/rtc ] ; then
427       ewarn "Warning: realtime clock not available, trying to execute hwclock anyway." ; eend 0
428     fi
429
430     ERROR=$(TZ="$KTZ" hwclock $UTC -s 2>&1 | head -1) ; RC=$?
431     if [ -n "$ERROR" ] ; then
432        eindent
433        ERROR=$(TZ="$KTZ" hwclock $UTC -s --directisa 2>&1 | head -1)
434        if [ -n "$ERROR" ] ; then
435           eerror "Problem running hwclock: $ERROR" ; eend 1
436        fi
437        eoutdent
438     fi
439
440  fi
441 }
442 # }}}
443
444 # {{{ print kernel info
445 config_kernel(){
446   vmware-detect &>/dev/null && VMWARE="inside ${WHITE}VMware/Qemu${NORMAL}"
447   [ -d /proc/xen ] && VMWARE='' # vmware-detect returns '0' when running with a Xen-enabled kernel
448   einfo "Running Linux Kernel $KERNEL $VMWARE" ; eend 0
449   if [ -r /proc/cpuinfo ] ; then
450      if egrep -q '^flags.*(vmx|svm)' /proc/cpuinfo ; then
451        eindent
452        einfo 'CPU(s) featuring virtualization technology detected' ; eend 0
453        eoutdent
454      fi
455   fi
456   if [ -d /proc/xen ] ; then
457      eindent
458      einfo 'Running kernel featuring support for Xen detected' ; eend 0
459      eoutdent
460   fi
461 }
462 # }}}
463
464 # {{{ ld.so.cache + depmod
465 config_ld_mod(){
466 if [ -n "$INSTALLED" ]; then
467  if ! [ -r /etc/grml.first.boot ] ; then
468   einfo "Running from HD for the first time, regenerate ld.so.cache and modules.dep:"
469   eindent
470 # Regenerate ld.so.cache and module dependencies on HD
471     einfo "Running ldconfig" ; ldconfig  ; eend $?
472     einfo "Running depmod"   ; depmod -a ; eend $?
473     touch /etc/grml.first.boot
474     eend 0
475   eoutdent
476  fi
477 fi
478 }
479 # }}}
480
481 # {{{ timezone
482 config_timezone(){
483  # don't touch the files if running from harddisk:
484  if [ -z "$INSTALLED" ]; then
485     KTZ="$(getbootparam 'tz' 2>>$DEBUG)"
486     if [ -n "$KTZ" ] ; then
487        if [ ! -f "/usr/share/zoneinfo/$KTZ" ]
488        then
489           ewarn "Warning: unknown timezone $KTZ"; eend 0
490        else
491           einfo "Setting timezone."
492           # update debconf
493           area=$(echo $KTZ | cut -d '/' -f1)
494           zone=$(echo $KTZ | cut -d '/' -f2)
495           echo "tzdata tzdata/Areas       select $area" | debconf-set-selections
496           echo "tzdata tzdata/Zones/$area select $zone" | debconf-set-selections
497           # update files
498           echo $KTZ > /etc/timezone
499           rm -f /etc/localtime
500           cp "/usr/share/zoneinfo/$KTZ" /etc/localtime ; eend $?
501        fi
502     fi
503  fi
504 }
505 # }}}
506
507 # small computer / nearly no ram {{{
508 config_small(){
509
510 RAM=$(/usr/bin/gawk '/MemTotal/{print $2}' /proc/meminfo)
511 # MEM=$(/usr/bin/gawk 'BEGIN{m=0};/MemFree|Cached|SwapFree/{m+=$2};END{print m}' /proc/meminfo)
512 eindent
513
514 if checkbootparam 'small'; then
515   einfo "Information: ${RAM} kB of RAM available." ; eend 0
516   einfo "Bootoption small detected. Activating small system."
517   if [ -r /etc/inittab.small ] ; then
518     mv /etc/inittab /etc/inittab.normal
519     mv /etc/inittab.small /etc/inittab
520   else
521     sed -i 's/^9/#&/' /etc/inittab
522     sed -i 's/^10/#&/' /etc/inittab
523     sed -i 's/^11/#&/' /etc/inittab
524     sed -i 's/^12/#&/' /etc/inittab
525   fi
526   /sbin/telinit q ; eend $?
527 else
528   if checkgrmlsmall ; then
529     if [[ $RAM -lt 25000 ]] ; then
530       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
531       ewarn "At least 32MB of RAM should be available for grml-small." ; eend 1
532       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
533       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
534       /bin/zsh --login
535     else
536       einfo "Information: ${RAM} kB of RAM available." ; eend 0
537     fi
538   else
539     if [[ $RAM -lt 58000 ]] ; then
540       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
541       ewarn "At least 64MB of RAM should be available for grml." ; eend 1
542       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
543       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
544       /bin/zsh --login
545     else
546       einfo "Information: ${RAM} kB of RAM available." ; eend 0
547     fi
548   fi
549 fi
550 eoutdent
551 }
552 # }}}
553
554 # skip startup of w3m {{{
555 config_fast(){
556 if checkbootparam 'fast'; then
557   ewarn "Bootoption fast detected. Skipping startup of grml-quickconfig."
558     sed -i 's#^1:.*#1:12345:respawn:/usr/bin/openvt -f -c 1 -w -- /bin/zsh#' /etc/inittab
559   /sbin/telinit q ; eend $?
560 fi
561 }
562 # }}}
563
564 # activate serial console {{{
565 config_console(){
566 if checkbootparam 'console'; then
567   local line
568   local ws
569   ws='   '
570
571   einfo "Bootoption for serial console detected:"
572
573   line="$CMDLINE x "
574   this=""
575   line="${line#*[$ws]}"
576   local telinitq=""
577   while [ -n "$line" ]; do
578     case "$this" in
579       console=*)
580         local serial="$this"
581         local device="${this%%,*}"
582         local device="${device##*=}"
583         if echo $serial | grep -q ttyS ; then
584           local option="${serial##*,}"
585           # default (works for kvm & CO):
586           local speed="115200,57600,38400,19200,9600,4800,2400,1200";
587           # ... unless overriden by command line:
588           case "$option" in
589             115200*) speed=115200 ;;
590              57600*) speed=57600 ;;
591              38400*) speed=38400 ;;
592              19200*) speed=19200 ;;
593               9600*) speed=9600 ;;
594               4800*) speed=4800 ;;
595               2400*) speed=2400 ;;
596               1200*) speed=1200 ;;
597           esac
598           eindent
599             einfo "Activating console login on device ${device} with speed ${speed}."
600             local number="${device#ttyS}"
601             sed -i "/^T$number:/d;/^#grmlserial#/iT$number:23:respawn:/bin/bash -c \"/sbin/getty -L $device -l /usr/bin/zsh-login $speed vt100 || sleep 30\"" /etc/inittab
602             eend $?
603             telinitq="1"
604           eoutdent
605         fi
606         ;;
607     esac
608     this="${line%%[$ws]*}"
609     line="${line#*[$ws]}"
610   done
611
612   if [ -n "$telinitq" ]; then
613     /sbin/telinit q
614   fi
615   eend $?
616 fi
617 }
618 # }}}
619
620 # For burning on IDE-CD-Roms, k3b (and others) check for special permissions {{{
621 config_cdrom_perm(){
622 CDROMS=""
623 for DEVICE in /proc/ide/hd?; do
624  [ "$(cat $DEVICE/media 2>/dev/null)" = "cdrom" ] && CDROMS="$CDROMS /dev/${DEVICE##*/}"
625 done
626 [ -n "$CDROMS" ] && { chown root.cdrom $CDROMS; chmod 666 $CDROMS; } 2>/dev/null
627 }
628 # }}}
629
630 # {{{ Bring up loopback interface now
631 config_local_net(){
632  if [ -z "$INSTALLED" ] ; then
633     if grep -q 'iface lo inet loopback' /etc/network/interfaces 2>/dev/null ; then
634        grep -q lo=lo /etc/network/run/ifstate 2>/dev/null || ifup lo
635     else
636        ifconfig lo up
637     fi
638  fi
639 }
640 # }}}
641
642 # firewire devices {{{
643 # the raw1394 driver does not yet export info into SYSFS,
644 # so let's create raw1394 device manually
645 # http://www.michael-prokop.at/blog/index.php?p=352
646 config_firewire_dev(){
647 if checkbootparam 'nofirewiredev' ; then
648   ewarn "Skipping creating some firewire devices as requested on boot commandline." ; eend 0
649 else
650 #if [ "${KERNEL%-*}" == "2.6.11" ] ; then
651   einfo "Creating some firewire devices (fix kernel 2.6-bug)."
652 #  cd /dev && MAKEDEV video1394 raw1394
653   [ -r /dev/raw1394 ]   || mknod /dev/raw1394 c 171 0
654   [ -r /dev/video1394 ] || mknod -m 666 /dev/video1394 c 171 16
655 # mknod -m 666 /dev/dv1394 c 171 32 # for NTSC
656   [ -r /dev/dv1394 ]    || mknod -m 666 /dev/dv1394 c 171 34 # for PAL
657   chown -R root:video /dev/raw1394 /dev/video1394 /dev/dv1394
658   chmod -R 664 /dev/raw1394 /dev/video1394 /dev/dv1394 ; eend $?
659 fi
660 #fi
661 }
662 # }}}
663
664 # {{{ copy passwd-lockfile to ramdisk (fix unionfs-behaviour)
665 # otherwise we will get: passwd: Authentication token lock busy
666 config_fix_passwd(){
667  if [ -z "$INSTALLED" ] ; then
668   touch /etc/.pwd.lock
669  fi
670 }
671 # }}}
672
673 # {{{ CD Checker
674 config_testcd(){
675 if [ -n "$TESTCD" ]; then
676    einfo "Checking CD data integrity as requested by '${WHITE}testcd${NORMAL}' boot option."
677    einfo "Reading files and checking against GRML/md5sums, this may take a while..."
678    echo -n "${RED}"
679
680    if [ -n "${LIVECD_PATH}"/GRML ] ; then
681       ( cd "${LIVECD_PATH}"/GRML ; rm -f /tmp/md5sum.log ; md5sum -c md5sums 2>&1 | tee /tmp/md5sum.log ; RC=$? )
682    else
683       echo "${RED} *** Error: Could not find md5sum file.                           ***"
684    fi
685
686    if [ "$RC" = "0" ]; then
687       einfo "Everything looks OK" ; eend 0
688    else
689       eerror 'Checksum failed for theses files:' ; eend 1
690       egrep -v '(^md5sum:|OK$)' /tmp/md5sum.log
691       eerror 'Data on the grml medium is possibly incomplete/damaged or...'
692       eerror '... RAM of your computer is broken.' ; eend 1
693       einfon "Hit return to continue, or press the reset button to quit."
694      read a
695    fi
696
697    eend 0
698 fi
699 }
700 # }}}
701
702 # {{{ hardware detection via discover
703 config_discover(){
704 if checkbootparam 'nodisc' ; then
705   ewarn "Skipping hardware detection via discover as requested on boot commandline." ; eend 0
706 else
707  if [ -x /sbin/discover ] ; then
708   einfo "Discovering hardware. Trying to load the following modules in background:"
709    eindent
710    einfo "$(discover --data-path=linux/module/name --data-path=linux/modules/options --format="%s %s" --data-version=`uname -r` --enable-bus all | sort -u | xargs echo)"
711    eoutdent
712   /sbin/discover-modprobe -v >>$DEBUG 2>&1 &
713   eend 0
714  else
715   eerror "Application discover not available. Information: udev should handle hardware recognition." ; eend 0
716  fi
717 fi
718 }
719 # }}}
720
721 # {{{ hardware detection via hwinfo
722 config_hwinfo(){
723 if checkbootparam 'hwinfo' >>$DEBUG 2>&1; then
724   einfo "Discovering hardware via hwinfo:"
725   MODULES=$(su grml hwinfo | grep "Cmd: \"modprobe" | awk '{print $5}' | sed 's/"//')
726   echo -n "  Loading modules: "
727   for i in `echo $MODULES` ; do echo -n $i && modprobe $i ; done
728   eend 0
729 fi
730 }
731 # }}}
732
733 # {{{ disable hotplug agents on request
734 config_hotplug_agent(){
735 if checkbootparam 'noagent' ; then
736   AGENT="$(getbootparam 'noagent' 2>>$DEBUG)"
737   AGENTLIST=$(echo "$AGENT" | sed 's/,/\\n/g')
738   AGENTNL=$(echo "$AGENT" | sed 's/,/ /g')
739   einfo "Disabling hotplug-agent(s) $AGENTNL"
740   for agent in $(echo -e $AGENTLIST) ; do
741     mv /etc/hotplug/${agent}.rc /etc/hotplug/${agent}.norc
742   done
743   [ "$?" == "0" ] ; eend $?
744 fi
745 }
746 # }}}
747
748 # {{{ blacklist of hotplug-modules
749 config_hotplug_blacklist(){
750 if checkbootparam 'black' ; then
751   BLACK="$(getbootparam 'black' 2>>$DEBUG)"
752   BLACKLIST=$(echo "$BLACK" | sed 's/,/\\n/g')
753   BLACKNL=$(echo "$BLACK" | sed 's/,/ /g')
754   einfo "Blacklisting $BLACKNL via /etc/hotplug/blacklist.d/hotplug-light"
755   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist.d/hotplug-light
756   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist
757   eend 0
758 fi
759 }
760 # }}}
761
762 # {{{ run hotplug
763 config_hotplug(){
764 if checkbootparam 'nohotplug' ; then
765   ewarn "Skipping running hotplug as requested on boot commandline." ; eend 0
766 else
767   if [ -r /etc/init.d/hotplug ] ; then
768     einfo "Starting hotplug system in background."
769     /etc/init.d/hotplug start >>$DEBUG 2>>$DEBUG &
770     eend 0
771   elif [ -r /etc/init.d/hotplug-light ] ; then
772     einfo "Starting hotplug-light system in background."
773     /etc/init.d/hotplug-light start >>$DEBUG 2>>$DEBUG &
774     eend 0
775   else
776     ewarn "No hotplug system found. Should be handled by udev. Skipping execution." ; eend 0
777   fi
778 fi
779 }
780 # }}}
781
782 # {{{ blacklist specific module [ used in /etc/init.d/udev ]
783 config_blacklist(){
784 if checkbootparam 'blacklist' ; then
785  if [ -z "$INSTALLED" ]; then
786   einfo "Bootoption blacklist found."
787   BLACK="$(getbootparam 'blacklist' 2>>$DEBUG)"
788   BLACKLIST_FILE='/etc/modprobe.d/grml.conf'
789   if [ -n "$BLACK" ] ; then
790     for module in $(echo ${BLACK//,/ }) ; do
791         einfo "Blacklisting module ${module} via ${BLACKLIST_FILE}."
792         echo "# begin entry generated by config_blacklist of grml-autoconfig" >> "$BLACKLIST_FILE"
793         echo "blacklist $module"     >> "$BLACKLIST_FILE"
794         echo "alias     $module off" >> "$BLACKLIST_FILE"
795         echo "# end   entry generated by config_blacklist of grml-autoconfig" >> "$BLACKLIST_FILE" ; eend $?
796     done
797   else
798    eerror "No given module for blacklist found. Blacklisting will not work therefore."
799   fi
800  else
801   ewarn "Backlisting via bootoption is not intended for use on harddisk installations." ; eend 1
802   eindent
803    einfo "Please blacklist the module(s) manually using the 'blacklist' script."
804   eoutdent
805  fi
806 fi
807 }
808 # }}}
809
810 # {{{ ACPI
811 config_acpi_apm(){
812 if [ -d /proc/acpi ]; then
813   if checkbootparam 'noacpi'; then
814     ewarn "Skipping ACPI Bios detection as requested via noacpi on boot commandline." ; eend 0
815   elif checkbootparam 'nogrmlacpi' ; then
816     ewarn "Skipping ACPI Bios detection as requested via nogrmlacpi on boot commandline." ; eend 0
817   else
818     einfo "ACPI Bios found, activating modules (disable via bootoption noacpi / nogrmlacpi): "
819     eindent
820     found=""
821     for a in /lib/modules/$KERNEL/kernel/drivers/acpi/*; do
822       basename="${a##*/}"
823       basename="${basename%%.*}"
824       case "$basename" in *_acpi)
825        egrep -qi "${basename%%_acpi}" /proc/acpi/dsdt 2>>$DEBUG || continue ;;
826       esac
827       modprobe $basename >>$DEBUG 2>&1 && found="yes"
828       local BASE="$BASE $basename"
829     done
830     if [ -n "$found" ] ; then
831       einfo "$BASE"  ; eend 0
832     else
833       ewarn "(none)" ; eend 1
834     fi
835     if ! ps x | grep -q /usr/sbin/acpid ; then
836       if ! [ -r /var/run/dbus/pid ] ; then
837         einfo "Starting acpi daemon."
838         /etc/init.d/acpid start >>$DEBUG 2>&1 ; eend $?
839       else
840         eerror "acpid error: it seems you are running d-bus/hal, but acpid needs to be started before d-bus."
841         eerror "Solution: please activate acpid via /etc/runlevel.conf"
842         eend 1
843       fi
844     else
845       ewarn "acpi daemon already running."
846       eend 0
847     fi
848     eoutdent
849   fi
850 else
851 # APM
852   if checkbootparam 'noapm'; then
853     ewarn "Skipping APM Bios detection as requested on boot commandline." ; eend 0
854   else
855     modprobe apm power_off=1 >>$DEBUG 2>&1
856     if [ "$?" = "0" ] ; then
857        if [ -x /etc/init.d/apmd ] ;then
858           einfo "APM Bios found, enabling power management functions."
859           /etc/init.d/apmd start ; eend $?
860        fi
861     else
862       eerror "Loading apm module failed." ; eend 1
863     fi
864   fi
865 fi
866 }
867 # }}}
868
869 # {{{ PCMCIA Check/Setup
870 # This needs to be done before other modules are being loaded (by hwsetup)
871 config_pcmcia(){
872 if checkbootparam 'nopcmcia'; then
873   ewarn "Skipping PCMCIA detection as requested on boot commandline." ; eend 0
874 else
875   if /usr/sbin/laptop-detect ; then
876     einfo "Detected Laptop - checking for PCMCIA." && eend 0
877     modprobe pcmcia_core >>$DEBUG 2>&1
878     # Try Cardbus or normal PCMCIA socket drivers
879     modprobe yenta_socket >>$DEBUG 2>&1 || modprobe i82365 >>$DEBUG 2>&1 || modprobe pd6729 >>$DEBUG 2>&1 || modprobe tcic >>$DEBUG 2>&1
880     if [ "$?" = "0" ]; then
881       modprobe ds >>$DEBUG 2>&1
882       if [ -d /proc/bus/pccard ] ; then
883        if [ -x /sbin/cardmgr ] ; then
884         einfo "PCMCIA found, starting cardmgr."
885         cardmgr >>$DEBUG 2>&1 && sleep 6 && eend 0
886        else
887         eerror "No cardmgr found. Make sure package pcmciautils is installed, it should handle it instead." ; eend 1
888        fi
889       fi
890     fi
891   fi
892 fi
893 }
894 # }}}
895
896 # {{{ run software synthesizer via speakup
897 config_swspeak(){
898    if checkbootparam 'swspeak' ; then
899       einfo "Bootoption swspeak found."
900
901       if [ ! -d /proc/speakup/ ] && ! grep -q speakup_soft /proc/modules ; then
902          ewarn "Kernel does not support software speakup - trying to load kernel module:" ; eend 0
903          eindent
904          einfo "Loading speakup_soft"
905          if modprobe speakup_soft ; then
906             eend 0
907          else
908             flitewrapper "Fatal error setting up software speakup"
909             eend 1
910             return 1
911          fi
912          eoutdent
913       fi
914
915       if [ -d /proc/speakup/ ] || grep -q speakup_soft /proc/modules ; then
916          einfo "Kernel supports speakup." ; eend 0
917          eindent
918             einfo "Just run swspeak if you want to use software synthesizer via speakup."
919             flitewrapper "Finished activating software speakup. Just run swspeak when booting finished."
920          eoutdent
921       else
922          eerror "Kernel does not seem to support speakup. Skipping swspeak." ; eend 1
923          flitewrapper "Kernel does not seem to support speakup. Sorry."
924       fi
925    fi
926 }
927 # }}}
928
929 # {{{ support hardware synthesizer via speakup
930 config_hwspeak(){
931    if checkbootparam 'speakup.synth' ; then
932       einfo "Bootoption speakup.synth found."
933       eindent
934
935       module="$(getbootparam 'speakup.synth' 2>>$DEBUG)"
936       if [ -z "$module" ] ; then
937          eerror "Sorry, no speakup module specified for bootoption speakup.synth."
938          flitewrapper "Sorry, no speakup module specified for bootoption speakup.synth."
939       else
940          einfo "Trying to load $module"
941          modprobe "speakup_${module}"
942          eend $?
943       fi
944
945       if [ -d /proc/speakup/ ] || grep -q speakup /proc/modules ; then
946          einfo "Kernel should support speakup now." ; eend 0
947          flitewrapper "Kernel should support speakup now."
948       else
949          eerror "Kernel or hardware do not seem to support speakup. Skipping hwspeak." ; eend 1
950          flitewrapper "Kernel or hardware do not seem to support speakup. Sorry."
951       fi
952
953       eoutdent
954
955    # hwspeak:
956    elif checkbootparam 'hwspeak' ; then
957       einfo "Bootoption hwspeak found."
958
959       if [ ! -d /proc/speakup/ ] && ! grep -q speakup /proc/modules ; then
960          ewarn "Kernel does not support hardware speakup - trying to load kernel modules:" ; eend 0
961          eindent
962          if ! [ -d "/lib/modules/${KERNEL}/extra/speakup/" ] ; then
963             eerror "Kernel does not provide speakup modules, sorry." ; eend 1
964          else
965            for module in $(find "/lib/modules/${KERNEL}/extra/speakup/" -name \*.ko | \
966                            sed 's#.*speakup/##g ; s#.ko$##g' | \
967                            grep -ve speakup_soft -ve speakup_dummy | sort -u) ; do
968               einfo "Trying to load $module"
969               modprobe $module
970               eend $?
971            done
972          fi
973          eoutdent
974       fi
975
976       if [ -d /proc/speakup/ ] || grep -q speakup /proc/modules ; then
977          einfo "Kernel should support speakup now." ; eend 0
978          flitewrapper "Kernel should support speakup now."
979       else
980          eerror "Kernel or hardware do not seem to support speakup. Skipping hwspeak." ; eend 1
981          flitewrapper "Kernel or hardware do not seem to support speakup. Sorry."
982       fi
983    fi
984 }
985 # }}}
986
987 # {{{ Check for blind option or brltty
988 config_blind(){
989 BLIND=""
990 checkbootparam 'blind' && BLIND="yes"
991 BRLTTY="$(getbootparam 'brltty' 2>>$DEBUG)"
992
993 if [ -n "$BLIND" -o -n "$BRLTTY" ]; then
994   if [ -x /sbin/brltty ]; then
995     # Blind option detected, start brltty now.
996     # modprobe serial_core parport_serial generic_serial && echo "done"
997     CMD=brltty
998     BRLTYPE=""
999     BRLDEV=""
1000     BRLTEXT=""
1001     if [ -n "$BRLTTY" ]; then
1002       # Extra options
1003       BRLTYPE="${BRLTTY%%,*}"
1004       R="${BRLTTY#*,}"
1005       if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
1006         BRLTTY="$R"
1007         BRLDEV="${BRLTTY%%,*}"
1008         R="${BRLTTY#*,}"
1009         if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
1010           BRLTTY="$R"
1011           BRLTEXT="${BRLTTY%%,*}"
1012           R="${BRLTTY#*,}"
1013         fi
1014       fi
1015     fi
1016     [ -n "$BRLTYPE" ] && CMD="$CMD -b $BRLTYPE"
1017     [ -n "$BRLDEV"  ] && CMD="$CMD -d $BRLDEV"
1018     [ -n "$BRLTEXT" ] && CMD="$CMD -t $BRLTEXT"
1019     einfo "Starting braille-display manager."
1020 #    ( exec $CMD & )
1021     ( sh -c "$CMD" & )
1022     sleep 2 && BLINDSOUND="yes"
1023     eend 0
1024   fi
1025 fi
1026 }
1027 # }}}
1028
1029 # {{{ AGP
1030 config_agp(){
1031 if checkbootparam 'forceagp' ; then
1032 # Probe for AGP. Hope this can fail safely
1033   grep -q "AGP" "/proc/pci" 2>>$DEBUG && { modprobe agpgart || modprobe agpgart agp_try_unsupported=1; } >>$DEBUG 2>&1 && einfo "AGP bridge detected." ; eend 0
1034 fi
1035 }
1036 # }}}
1037
1038 # {{{ automount(er)
1039 config_automounter(){
1040 if checkbootparam 'automounter' ; then
1041   RUNLEVEL="$(runlevel)"
1042   AUTOMOUNTER=""
1043   [ -x /etc/init.d/autofs ] && [ "$RUNLEVEL" != "N 1" ] && [ "$RUNLEVEL" != "N S" ] && AUTOMOUNTER="yes"
1044
1045 addautomount(){
1046 # /dev/ice  options
1047   d="${1##*/}"
1048   if [ -n "$AUTOMOUNTER" ]; then
1049     [ -d "/mnt/$d" -a ! -L "/mnt/$d" ] && rmdir /mnt/$d
1050     [ -d "/mnt/auto/$d" ] || mkdir -p "/mnt/auto/$d"
1051     [ -L "/mnt/$d" ]      || ln -s "/mnt/auto/$d" "/mnt/$d"
1052     anew="$d        -fstype=auto,$2 :$i"
1053     grep -q "$anew" "/etc/auto.mnt" || echo "$anew" >> /etc/auto.mnt
1054     AUTOMOUNTS="$AUTOMOUNTS $d"
1055     new="$1 /mnt/auto/$d  auto   users,noauto,exec,$2 0 0"
1056   else
1057     [ -d /mnt/$d ] && mkdir -p /mnt/$d
1058     new="$1 /mnt/$d  auto   users,noauto,exec,$2 0 0"
1059   fi
1060   grep -q "$new" "/etc/fstab" || echo "$new" >> /etc/fstab
1061 }
1062
1063   AUTOMOUNTS="floppy cdrom"
1064 # Add new devices to /etc/fstab and /etc/auto.mnt
1065   for i in /dev/cdrom?*; do
1066     if [ -L $i ]; then
1067       addautomount "$i" "ro"
1068     fi
1069   done
1070 fi
1071
1072 if [ -n "$AUTOMOUNTER" ]; then
1073 # Check for floppy dir, reinstall with automounter
1074   [ -d /mnt/floppy -a ! -L /mnt/floppy ] && rmdir /mnt/floppy
1075   [ -d /mnt/auto/floppy ] || mkdir -p /mnt/auto/floppy
1076   [ -L /mnt/floppy ] || ln -s /mnt/auto/floppy /mnt/floppy
1077   [ -d /mnt/cdrom -a ! -L /mnt/cdrom ] && rmdir /mnt/cdrom
1078   [ -d /mnt/auto/cdrom ] || mkdir -p /mnt/auto/cdrom
1079   [ -L /mnt/cdrom ] || ln -s /mnt/auto/cdrom /mnt/cdrom
1080   rm -f /etc/fstab.new
1081 # Replace paths from bootfloppy
1082   sed 's|/mnt/cdrom|/mnt/auto/cdrom|g;s|/mnt/floppy|/mnt/auto/floppy|g' /etc/fstab > /etc/fstab.new
1083   mv -f /etc/fstab.new /etc/fstab
1084 # Start automounter now
1085   einfo "Starting automounter for ${AUTOMOUNTS}."
1086   /etc/init.d/autofs start >>$DEBUG ; eend $?
1087 fi
1088 }
1089 # }}}
1090
1091 # {{{ Collect partitions from /proc/partitions first for enabling DMA
1092 check_partitions(){
1093 partitions=""
1094 IDEDISKS=""
1095 while read major minor blocks partition relax; do
1096   partition="${partition##*/}"
1097   [ -z "$partition" -o ! -e "/dev/$partition" ] && continue
1098   case "$partition" in
1099     hd?) IDEDISKS="$IDEDISKS $partition";;                # IDE  Harddisk, entire disk
1100     sd?) ;;                                               # SCSI Harddisk, entire disk
1101 #    [hs]d*) partitions="$partitions /dev/$partition";;    # IDE or SCSI disk partition
1102     [hs]d*|ub*) partitions="$partitions /dev/$partition";;    # IDE, USB or SCSI disk partition
1103   esac
1104 done <<EOT
1105 $(awk 'BEGIN{old="__start"}{if($0==old){exit}else{old=$0;if($4&&$4!="name"){print $0}}}' /proc/partitions)
1106 EOT
1107 }
1108 check_partitions >/dev/null 2>&1 # avoid output "check_partitions:3: read-only file system"
1109 # }}}
1110
1111 # {{{ Enable DMA for all IDE drives now if not disabled
1112 # Notice: Already done by linuxrc, but make sure it's done also on harddisk-installed systems
1113 config_dma(){
1114 if checkbootparam 'nodma'; then
1115   ewarn "Skipping DMA accelleration as requested on boot commandline." ; eend 0
1116 else
1117   for d in $(cd /proc/ide 2>>$DEBUG && echo hd[a-z]); do
1118     if test -d /proc/ide/$d; then
1119       if egrep -q 'using_dma[ \t]+0' /proc/ide/$d/settings 2>>$DEBUG; then
1120         MODEL="$(cat /proc/ide/$d/model 2>>$DEBUG)"
1121         test -z "$MODEL" && MODEL="[GENERIC IDE DEVICE]"
1122         einfo "Enabling DMA acceleration for: ${WHITE}$d        ${YELLOW}[${MODEL}]${NORMAL}"
1123         echo "using_dma:1" >/proc/ide/$d/settings
1124         eend 0
1125       fi
1126     fi
1127   done
1128 fi
1129 }
1130 # }}}
1131
1132 # {{{ Start creating /etc/fstab with HD partitions and USB SCSI devices now
1133 config_fstab(){
1134
1135 NOSWAP="yes" # we do not use swap by default!
1136 if checkbootparam 'swap' || checkbootparam 'anyswap' ; then
1137    NOSWAP=''
1138    checkbootparam 'anyswap' && export ANYSWAP='yes' || export ANYSWAP=""
1139 fi
1140
1141 if checkbootparam 'nofstab' || checkbootparam 'forensic' ; then
1142   ewarn "Skipping /etc/fstab creation as requested on boot commandline." ; eend 0
1143 else
1144   einfo "Scanning for harddisk partitions and creating /etc/fstab. (Disable this via boot option: nofstab)"
1145   iszsh && setopt nonomatch
1146   if [ -x /usr/sbin/rebuildfstab ] ; then
1147      config_userfstab || fstabuser=grml
1148      /usr/sbin/rebuildfstab -r -u $fstabuser -g $fstabuser ; eend $?
1149   else
1150      ewarn "Command rebuildfstab not found. Install package grml-rebuildfstab." ; eend 1
1151   fi
1152 fi # checkbootparam nofstab/forensic
1153
1154 # Scan for swap, config, homedir - but only in live-mode
1155 if [ -z "$INSTALLED" ] ; then
1156    [ -z "$NOSWAP" ] && einfo "Searching for swap partition(s) as requested."
1157    GRML_IMG=""
1158    GRML_SWP=""
1159    HOMEDIR="$(getbootparam 'home')"
1160    if [ -n "$partitions" ]; then
1161       while read p m f relax; do
1162         case "$p" in *fd0*|*proc*|*sys*|*\#*) continue;; esac
1163         partoptions="users,exec"
1164         fnew=""
1165         # it's a swap partition?
1166         case "$f" in swap)
1167           eindent
1168           if [ -n "$NOSWAP" ]; then
1169              ewarn "Ignoring swap partition ${WHITE}$p${NORMAL}. (Force usage via boot option 'swap', or execute grml-swapon)"
1170              eend 0
1171           else
1172              case "$(dd if=$p bs=1 count=6 skip=4086 2>/dev/null)" in
1173                    S1SUSP|S2SUSP|pmdisk|[zZ]*)
1174                      if [ -n "$ANYSWAP" ] ; then
1175                         einfo "Using swap partition ${WHITE}${p}${NORMAL} [bootoption anyswap found]."
1176                         swapon $p 2>>$DEBUG ; eend $?
1177                      else
1178                         ewarn "Suspend signature on ${WHITE}${p}${NORMAL} found, not using as swap. (Force usage via boot option: anyswap)"
1179                      fi
1180                      ;;
1181                    *)
1182                      if [[ "$p" == LABEL* ]] ; then
1183                         p=$(blkid -t $p | awk -F: '{print $1}')
1184                      fi
1185                      if grep -q $p /proc/swaps ; then
1186                         ewarn "Not using swap partition ${WHITE}${p}${NORMAL} as it is already in use." ; eend 0
1187                      else
1188                         if [ -b "$p" ] ; then
1189                         einfo "Using swap partition ${WHITE}${p}${NORMAL}."
1190                         swapon $p 2>>$DEBUG ; eend $?
1191                         else
1192                         ewarn "$p is not a valid block device - not using it therefore." ; eend 0
1193                         fi
1194                      fi
1195                      ;;
1196              esac # dd-check
1197           fi # -n "$NOSWAP
1198           eoutdent
1199           continue
1200           ;;
1201         esac # it's a swap partition?
1202
1203         # mount read-only
1204         MOUNTOPTS="ro"
1205         case "$f" in
1206           vfat|msdos|ntfs) MOUNTOPTS="$MOUNTOPTS,uid=${fstabuser},gid=${fstabuser}" ;;
1207           ext2|ext3|reiserfs|jfs|reiser4|xfs) MOUNTOPTS="$MOUNTOPTS,noatime" ;;
1208           *) continue ;;
1209           # *) NONEFOUND='1'; continue ;;
1210         esac
1211
1212         # use a swapfile
1213         if [ -z "$NOSWAP" ] ; then
1214            mount -o "$MOUNTOPTS" -t $f $p $m 2>>$DEBUG && MOUNTED=1 || continue
1215            # Activate swapfile, if exists
1216            SWAPFILE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ss][Ww][Pp] 2>/dev/null)"
1217         fi
1218         if [ -z "$NOSWAP" -a -n "$SWAPFILE" -a -f "$SWAPFILE" ]; then
1219            mount -o remount,rw $m && MOUNTED=1
1220            if swapon "$SWAPFILE" 2>>$DEBUG ; then
1221               eindent
1222                 einfo "Using GRML swapfile ${WHITE}${SWAPFILE}${NORMAL}."
1223               eoutdent
1224               fnew="$SWAPFILE swap swap defaults 0 0"
1225               grep -q "$fnew" "/etc/fstab" || echo "$fnew" >> /etc/fstab
1226               GRML_SWP="$GRML_SWP $SWAPFILE"
1227               eend 0
1228            fi
1229            mount -o remount,ro $m 2>>$DEBUG && MOUNTED=1
1230         fi
1231
1232         # use a image as home
1233         IMAGE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ii][Mm][Gg] 2>/dev/null)"
1234         if [ -z "$GRML_IMG" -a -n "$IMAGE" -a -f "$IMAGE" ]; then
1235            if [ -n "$HOMEDIR" ]; then
1236               if [ "$HOMEDIR" != "scan" -a "$HOMEDIR" != "$IMAGE" -a "$HOMEDIR" != "${IMAGE%/*.*}" ]; then
1237                  continue
1238               fi
1239            fi
1240            if type -a grml-image >/dev/null 2>&1 && grml-image "$IMAGE" </dev/console >/dev/console 2>&1; then
1241               GRML_IMG="$IMAGE"
1242               mount -o remount,ro $m 2>>$DEBUG && MOUNTED=1
1243            fi
1244         fi
1245         eend 0
1246
1247         # Umount, if not in use
1248         [ -n "$MOUNTED" ] && umount -r $m 2>/dev/null
1249
1250       done <<EOT
1251       $(cat /etc/fstab)
1252 EOT
1253    fi # -n $partitions
1254 fi # -z $INSTALLED
1255 }
1256 # }}}
1257
1258 # {{{ Mouse
1259 config_mouse(){
1260 if [ -n "$MOUSE_DEVICE" ] ; then
1261   einfo "Detecting mouse: ${MOUSE_FULLNAME} at ${MOUSE_DEVICE}" ; eend $?
1262 fi
1263 }
1264 # }}}
1265
1266 # {{{ IPv6 configuration
1267 # Load IPv6 kernel module and print IP adresses
1268 config_ipv6(){
1269 if checkbootparam 'ipv6'; then
1270   einfo "Enabling IPv6 as requested on boot commandline (sleeping for 2 seconds)"
1271   modprobe ipv6
1272   # we probably need some time until stateless autoconfiguration has happened
1273   sleep 2
1274   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1275   for DEVICE in `echo "$NETDEVICES"`; do
1276     eindent
1277       einfo "$DEVICE:"
1278       ADDRESSES="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{print $3}')"
1279       COUNT="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{ sum += 1};END {print sum }')"
1280       eindent
1281         for ADDR in `echo "$ADDRESSES"` ; do
1282             einfo "$ADDR"
1283         done
1284         if [ "$COUNT" -eq "0" ] ; then
1285            einfo "(none)" ; eend 1
1286         fi
1287       eoutdent
1288     eoutdent
1289   done
1290   eend 0
1291 fi
1292 }
1293 # }}}
1294
1295 # {{{ CPU-detection
1296 config_cpu(){
1297 if checkbootparam 'nocpu'; then
1298   ewarn "Skipping CPU detection as requested on boot commandline." ; eend 0
1299   return 0
1300 fi
1301
1302 if [[ $(grep -c processor /proc/cpuinfo) -gt 1 ]] ; then
1303    einfo "Detecting CPU:"
1304    CPU=$(awk -F: '/^processor/{printf " Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG)
1305    echo $CPU | sed 's/ \{1,\}/ /g'
1306    eend 0
1307 else
1308    einfo "Detecting CPU: `awk -F: '/^processor/{printf " Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG` " ; eend 0
1309 fi
1310
1311 # Virtual Box supports ACPI and laptop-detect would return with '0', so check for it:
1312 if [ -r /proc/acpi/battery/BAT0/info ] && grep -q 'OEM info:.*innotek' /proc/acpi/battery/BAT0/info ; then
1313    einfo 'Virtual Box detected, skipping cpufreq setup.' ; eend 0
1314    return 0
1315 fi
1316
1317 if [ -x /etc/init.d/loadcpufreq ] ; then
1318    einfo "Trying to set up cpu frequency scaling:"
1319    eindent
1320    SKIP_CPU_GOVERNOR=''
1321    LOADCPUFREQ=$(mktemp)
1322    /etc/init.d/loadcpufreq start >"$LOADCPUFREQ" 2>&1 ; RC=$?
1323    if grep -q FATAL "$LOADCPUFREQ" ; then
1324       eindent
1325         SKIP_CPU_GOVERNOR=1
1326         oldIFS="$IFS"
1327         IFS="
1328 "
1329          for line in $(grep FATAL "$LOADCPUFREQ" | sed 's/.*FATAL: //; s/ (.*)//') ; do
1330              eerror "$line" ; eend $RC
1331          done
1332          IFS="$oldIFS"
1333       eoutdent
1334    elif grep -q done "$LOADCPUFREQ" ; then
1335       MODULE=$(grep done "$LOADCPUFREQ" | sed 's/.*done (\(.*\))./\1/')
1336       if [ -n "$MODULE" -a "$MODULE" != none ]; then
1337          einfo "Loading cpufreq kernel module $MODULE" ; eend 0
1338       else
1339          ewarn "Could not find an appropriate kernel module for cpu frequency scaling." ; eend 1
1340       fi
1341    fi
1342
1343    rm -f $LOADCPUFREQ
1344
1345    if [ -z "$SKIP_CPU_GOVERNOR" ] ; then
1346       einfo "Loading cpufreq_ondemand, setting ondemand governor"
1347       RC=0
1348       if modprobe cpufreq_ondemand ; RC=$? ; then
1349          for file in $(find /sys/devices/system/cpu/ -name scaling_governor 2>/dev/null) ; do
1350             echo ondemand > $file
1351          done
1352       fi
1353       eend $RC
1354    fi # cpu-governor
1355
1356    eoutdent
1357 fi
1358 }
1359 # }}}
1360
1361 # {{{ autostart of ssh
1362 config_ssh(){
1363 if checkbootparam 'ssh' ; then
1364    SSH_PASSWD=''
1365    SSH_PASSWD="$(getbootparam 'ssh' 2>>$DEBUG)"
1366    einfo "Bootoption ssh found, trying to set password for user grml."
1367    eindent
1368    if [ -z "$SSH_PASSWD" ] ; then
1369       if [ -x /usr/bin/apg ] ; then
1370          SSH_PASSWD="$(apg -M NL -a 0 -m 8 -x 12 -n 1)"
1371       elif [ -x /usr/bin/gpw ] ; then
1372          SSH_PASSWD="$(gpw 1)"
1373       elif [ -x /usr/bin/pwgen ] ; then
1374          SSH_PASSWD="$(pwgen -1 8)"
1375       elif [ -x /usr/bin/hexdump ] ; then
1376          SSH_PASSWD="$(dd if=/dev/urandom bs=14 count=1 2>/dev/null | hexdump | awk '{print $3 $4}')"
1377       elif [ -n "$RANDOM" ] ; then
1378          SSH_PASSWD="grml${RANDOM}"
1379       else
1380          SSH_PASSWD=''
1381          eerror "Empty passphrase and neither pwgen nor hexdump nor \$RANDOM found. Skipping."
1382          eend 1
1383       fi
1384
1385       if [ -n "$SSH_PASSWD" ] ; then
1386          ewarn "No given password for ssh found. Using random password: $SSH_PASSWD" ; eend 0
1387       fi
1388    fi
1389    eoutdent
1390
1391    # finally check if we have a password we can use:
1392    if [ -n "$SSH_PASSWD" ] ; then
1393       # chpasswd sucks, seriously.
1394       if chpasswd --help 2>&1 | grep -q -- '-m,' ; then
1395         echo "grml:$SSH_PASSWD" | chpasswd -m
1396       else
1397         echo "grml:$SSH_PASSWD" | chpasswd
1398       fi
1399    fi
1400
1401    einfo 'Starting secure shell server in background.'
1402    /etc/init.d/rmnologin start >>$DEBUG 2>>$DEBUG
1403    /etc/init.d/ssh start >>$DEBUG 2>>$DEBUG &
1404    eend $?
1405
1406    eindent
1407    ewarn 'Warning: please change the password for user grml as soon as possible!'
1408    eoutdent
1409 fi
1410 }
1411 # }}}
1412
1413 # {{{ autostart of x11vnc
1414 config_vnc(){
1415
1416 USER=grml # TODO: make it dynamically configurable
1417 if checkbootparam 'vnc' ; then
1418    VNC_PASSWD=''
1419    VNC_PASSWD="$(getbootparam 'vnc' 2>>$DEBUG)"
1420    einfo "Bootoption vnc found, trying to set password for user $USER."
1421    eindent
1422    if [ -z "$VNC_PASSWD" ] ; then
1423       if [ -x /usr/bin/apg ] ; then
1424          VNC_PASSWD="$(apg -M NL -a 0 -m 8 -x 12 -n 1)"
1425       elif [ -x /usr/bin/gpw ] ; then
1426          VNC_PASSWD="$(gpw 1)"
1427       elif [ -x /usr/bin/pwgen ] ; then
1428          VNC_PASSWD="$(pwgen -1 8)"
1429       elif [ -x /usr/bin/hexdump ] ; then
1430          VNC_PASSWD="$(dd if=/dev/urandom bs=14 count=1 2>/dev/null | hexdump | awk '{print $3 $4}')"
1431       elif [ -n "$RANDOM" ] ; then
1432          VNC_PASSWD="${USER}${RANDOM}"
1433       else
1434          VNC_PASSWD=''
1435          eerror "Empty passphrase and neither pwgen nor hexdump nor \$RANDOM found. Skipping."
1436          eend 1
1437       fi
1438
1439       if [ -n "$VNC_PASSWD" ] ; then
1440          ewarn "No given password for vnc found. Using random password: $VNC_PASSWD" ; eend 0
1441       fi
1442    fi
1443    eoutdent
1444
1445    # finally check if we have a password we can use:
1446    if [ -n "$VNC_PASSWD" ] ; then
1447
1448       VNCDIR="/home/${USER}/.vnc"
1449       [ -d "$VNCDIR" ] || mkdir "$VNCDIR"
1450
1451       if [ ! -x /usr/bin/x11vnc ] ; then
1452          eerror "Error: x11vnc not found - can not set up vnc. Please make sure to install the x11vnc package."
1453          eend 1
1454       else
1455          /usr/bin/x11vnc -storepasswd "$VNC_PASSWD" "$VNCDIR"/passwd ; eend $?
1456          /bin/chown -R "$USER": "$VNCDIR"
1457       fi
1458    fi
1459    if checkbootparam 'vnc_connect' ; then
1460       VNC_CONNECT=''
1461       VNC_CONNECT="$(getbootparam 'vnc_connect' 2>>$DEBUG)"
1462       einfo "Bootoption vnc_connect found, will start vnc with connect to $VNC_CONNECT."
1463       #store the options in a file
1464       VNCDIR="/home/${USER}/.vnc"
1465       [ -d "$VNCDIR" ] || mkdir "$VNCDIR"
1466       echo " --connect $VNC_CONNECT " >> $VNCDIR/options
1467    fi
1468 fi
1469 }
1470 # }}}
1471
1472 # {{{ set password for user grml
1473 config_passwd(){
1474 if checkbootparam 'passwd' >>$DEBUG 2>&1; then
1475   einfo "Bootoption passwd found."
1476   PASSWD="$(getbootparam 'passwd' 2>>$DEBUG)"
1477   if [ -n "$PASSWD" ] ; then
1478     echo "grml:$PASSWD" | chpasswd -m ; eend $?
1479   else
1480     eerror "No given password for ssh found. Autostart of SSH will not work." ; eend 1
1481   fi
1482   eindent
1483     ewarn "Warning: please change the password for user grml set via bootparameter as soon as possible!"
1484   eoutdent
1485 fi
1486 }
1487 # }}}
1488
1489 # {{{ Sound
1490 config_mixer () {
1491    if ! [ -x /usr/bin/amixer ] ; then
1492       eerror "amixer binary not available. Can not set sound volumes therefore."
1493       eend 1
1494    else
1495       if ! [ -r /proc/asound/cards ] ; then
1496          ewarn "No soundcard present, skipping mixer settings therefore."
1497          eend 0
1498          return
1499       fi
1500
1501       for card in $(cat /proc/asound/cards| grep -e '^\s*[0-9]' | awk '{print $1}') ; do
1502          einfo "Configuring soundcard \"$(cat /proc/asound/cards| awk -F\[ '/^ '$card'/{ FS=" "; $0=$2; print $1 }' )\""
1503          eindent
1504
1505          if checkbootparam 'vol' ; then
1506             VOL="$(getbootparam 'vol' 2>>$DEBUG)"
1507             if [ -z "$VOL" ] ; then
1508                eerror "Bootoption vol found but no volume level/parameter given. Using defaults (75%)."
1509                VOL='75'
1510                eend 1
1511             fi
1512          else
1513             VOL='75'
1514          fi
1515
1516          if checkbootparam 'nosound' ; then
1517             einfo "Muting sound devices on request."
1518             ERROR=$(amixer -q set Master mute)
1519             RC=$?
1520             if [ -n "$ERROR" ] ; then
1521                eindent
1522                eerror "Problem muting sound devices: $ERROR"
1523                eoutdent
1524             fi
1525             eend $RC
1526          elif [ -z "$INSTALLED" ] ; then
1527             einfo "Setting mixer volumes to level ${WHITE}${VOL}${NORMAL}."
1528
1529             if checkbootparam 'micvol' ; then
1530                MICVOL="$(getbootparam 'micvol' 2>>$DEBUG)"
1531             else
1532                MICVOL=0
1533             fi
1534
1535             for CONTROL in Master PCM ; do
1536                if amixer -q | grep -q "Simple mixer control '$CONTROL'" ; then
1537                   amixer -q set "${CONTROL}" "${VOL}"%
1538                   eend $?
1539                fi
1540             done
1541
1542             if [ ${MICVOL} -ne 0 ] ; then
1543                einfo "Setting microphone to ${WHITE}${MICVOL}${NORMAL}."
1544                amixer -q set "Mic" $MICVOL &> /dev/null
1545                eend $?
1546             fi
1547          fi # checkbootparam 'nosound'
1548          eoutdent
1549       done
1550    fi
1551 }
1552 # }}}
1553
1554 # {{{ modem detection
1555 config_modem(){
1556 if checkbootparam 'nomodem'; then
1557   ewarn "Skipping check for AC97 modem controller as requested on boot commandline." ; eend 0
1558 else
1559   if [ -x /etc/init.d/sl-modem-daemon ] ; then
1560      if lspci | grep Intel | grep -q "AC'97 Modem Controller" ; then
1561         einfo "AC97 modem controller detected. Start it running 'Start sl-modem-daemon'."
1562         eend 0
1563      fi
1564   fi
1565 fi
1566 }
1567 # }}}
1568
1569 # {{{ keyboard add-ons
1570 config_setkeycodes(){
1571 if checkbootparam 'setkeycodes' ; then
1572  einfo "Setting keycodes as requested via bootparameter 'setkeycodes'."
1573   # MS MM keyboard add-on
1574   # fix
1575   setkeycodes e001 126 &>/dev/null
1576   setkeycodes e059 127 &>/dev/null
1577   # fn keys
1578   setkeycodes e03b 59 &>/dev/null
1579   setkeycodes e008 60 &>/dev/null
1580   setkeycodes e007 61 &>/dev/null
1581   setkeycodes e03e 62 &>/dev/null
1582   setkeycodes e03f 63 &>/dev/null
1583   setkeycodes e040 64 &>/dev/null
1584   setkeycodes e041 65 &>/dev/null
1585   setkeycodes e042 66 &>/dev/null
1586   setkeycodes e043 67 &>/dev/null
1587   setkeycodes e023 68 &>/dev/null
1588   setkeycodes e057 87 &>/dev/null
1589   setkeycodes e058 88 &>/dev/null
1590   # hp keycodes
1591   setkeycodes e00a 89 e008 90 &>/dev/null
1592  eend 0
1593 fi
1594 }
1595 # }}}
1596
1597 # {{{ wondershaper
1598 config_wondershaper(){
1599  if checkbootparam 'wondershaper' ; then
1600     WONDER="$(getbootparam 'wondershaper' 2>>$DEBUG)"
1601     CMD=wondershaper
1602     DEVICE=""
1603     DOWNSTREAM=""
1604     UPSTREAM=""
1605     if [ -n "$WONDER" ]; then
1606       # Extra options
1607       DEVICE="${WONDER%%,*}"
1608       R="${WONDER#*,}"
1609       if [ -n "$R" -a "$R" != "$WONDER" ]; then
1610         WONDER="$R"
1611         DOWNSTREAM="${WONDER%%,*}"
1612         R="${WONDER#*,}"
1613         if [ -n "$R" -a "$R" != "$WONDER" ]; then
1614           WONDER="$R"
1615           UPSTREAM="${WONDER%%,*}"
1616           R="${WONDER#*,}"
1617         fi
1618       fi
1619     fi
1620     [ -n "$DEVICE" ]     && CMD="$CMD $DEVICE"
1621     [ -n "$DOWNSTREAM" ] && CMD="$CMD $DOWNSTREAM"
1622     [ -n "$UPSTREAM" ]   && CMD="$CMD $UPSTREAM"
1623     einfo "Starting wondershaper (${CMD}) in background."
1624     ( sh -c $CMD & ) && eend 0
1625  fi
1626 }
1627 # }}}
1628
1629 # {{{ syslog-ng
1630 config_syslog(){
1631  if checkbootparam 'nosyslog'; then
1632     ewarn "Not starting syslog daemon as requested on boot commandline." ; eend 0
1633  else
1634     SYSLOGD=''
1635     [ -x /etc/init.d/syslog-ng ] && SYSLOGD='syslog-ng'
1636     [ -x /etc/init.d/rsyslog   ] && SYSLOGD='rsyslog'
1637     [ -x /etc/init.d/dsyslog   ] && SYSLOGD='dsyslog'
1638     [ -x /etc/init.d/sysklogd  ] && SYSLOGD='sysklogd'
1639     [ -x /etc/init.d/inetutils-syslogd ] && SYSLOGD='inetutils-syslogd'
1640
1641     if [ -z "$SYSLOGD" ] ; then
1642        eerror "No syslog daemon found." ; eend 1
1643     else
1644        einfo "Starting $SYSLOGD in background."
1645        /etc/init.d/$SYSLOGD start >>$DEBUG &
1646        eend 0
1647     fi
1648  fi
1649 }
1650 # }}}
1651
1652 # {{{ gpm
1653 config_gpm(){
1654  if checkbootparam 'nogpm'; then
1655   ewarn "Not starting GPM as requested on boot commandline." ; eend 0
1656  else
1657    if ! [ -r /dev/input/mice ] ; then
1658       eerror "No mouse found - not starting GPM." ; eend 1
1659    else
1660       einfo "Starting gpm in background."
1661       /etc/init.d/gpm start >>$DEBUG &
1662       # ( while [ ! -e /dev/psaux ]; do sleep 5; done; /etc/init.d/gpm start >>$DEBUG ) &
1663       eend 0
1664    fi
1665  fi
1666 }
1667 # }}}
1668
1669 # {{{ services
1670 config_services(){
1671  if checkbootparam 'services' ; then
1672     SERVICE="$(getbootparam 'services' 2>>$DEBUG)"
1673     SERVICELIST=$(echo "$SERVICE" | sed 's/,/\\n/g')
1674     SERVICENL=$(echo "$SERVICE" | sed 's/,/ /g')
1675     einfo "Starting service(s) ${SERVICENL} in background."
1676     for service in $(echo -e $SERVICELIST) ; do
1677        /etc/init.d/${service} start >>$DEBUG &
1678     done
1679     [ "$?" == "0" ] ; eend $?
1680  fi
1681 }
1682 # }}}
1683
1684 # {{{ remote files
1685 get_remote_file() {
1686   [ "$#" -eq 2 ] || ( echo "Error: wrong parameter for get_remote_file()" ; return 1 )
1687   SOURCE=$(eval echo "$1")
1688   TARGET="$2"
1689   getconfig() {
1690   wget --timeout=10 --dns-timeout=10  --connect-timeout=10 --tries=1 \
1691        --read-timeout=10 ${SOURCE} -O ${TARGET} && return 0 || return 1
1692   }
1693   einfo "Trying to get ${WHITE}${TARGET}${NORMAL}"
1694   counter=10
1695   while ! getconfig && [[ "$counter" != 0 ]] ; do
1696     echo -n "Sleeping for 1 second and trying to get config again... "
1697     counter=$(( counter-1 ))
1698     echo "$counter tries left" ; sleep 1
1699   done
1700   if [ -s "$TARGET" ] ; then
1701     einfo "Downloading was successfull." ; eend 0
1702     einfo "md5sum of ${WHITE}${TARGET}${NORMAL}: "
1703     md5sum ${TARGET} ; eend 0
1704     return 0;
1705   else
1706     einfo "Sorry, could not fetch ${SOURCE}" ; eend 1
1707     return 1;
1708  fi
1709 }
1710 # }}}
1711
1712 # {{{ config files
1713 config_netconfig(){
1714  if checkbootparam 'netconfig' ; then
1715   CONFIG="$(getbootparam 'netconfig' 2>>$DEBUG)"
1716   CONFIGFILE='/tmp/netconfig.grml'
1717
1718   if get_remote_file ${CONFIG} ${CONFIGFILE} ; then
1719     cd / && einfo "Unpacking ${WHITE}${CONFIGFILE}${NORMAL}:" && /usr/bin/unp $CONFIGFILE $EXTRACTOPTIONS ; eend $?
1720   fi
1721
1722  fi
1723 }
1724 # }}}
1725
1726 # {{{ remote scripts
1727 config_netscript() {
1728  if checkbootparam 'netscript' ; then
1729   CONFIG="$(getbootparam 'netscript' 2>>$DEBUG)"
1730   SCRIPTFILE='/tmp/netscript.grml'
1731
1732   if get_remote_file ${CONFIG} ${SCRIPTFILE} ; then
1733     chmod +x ${SCRIPTFILE}
1734     einfo "Running ${WHITE}${SCRIPTFILE}${NORMAL}:" && NETSCRIPT=${CONFIG} ${SCRIPTFILE} ; eend $?
1735   fi
1736
1737  fi
1738 }
1739 # }}}
1740
1741 # {{{ blindsound
1742 config_blindsound(){
1743  if checkbootparam 'blind' ; then
1744     beep
1745     flitewrapper "welcome to the gremel system"
1746  fi
1747 }
1748 # }}}
1749
1750 # {{{ welcome sound
1751 config_welcome(){
1752  if checkbootparam 'welcome' ; then
1753     flitewrapper "welcome to the gremel system"
1754  fi
1755 }
1756 # }}}
1757
1758 # {{{ fix/workaround for unionfs
1759 fix_unionfs(){
1760   if [ -z "$INSTALLED" ]; then
1761    touch /var/cache/apt/*cache.bin
1762   fi
1763 }
1764 # }}}
1765
1766 # {{{ start X window system via grml-x
1767 config_x_startup(){
1768 # make sure we start X only if startx is used *before* a nostartx option
1769 # so it's possible to disable automatic X startup using nostart
1770 if checkbootparam 'startx' && ! echo "$CMDLINE" | grep -q 'startx.*nostartx' ; then
1771  if [ -x "$(which X)" ] ; then
1772   if [ -z "$INSTALLED" ] ; then
1773    WINDOWMANAGER="$(getbootparam 'startx' 2>>$DEBUG)"
1774    if [ -z "$WINDOWMANAGER" ] ; then
1775      einfo "No window manager specified. Taking ${WHITE}wm-ng${NORMAL} as default." && eend 0
1776      WINDOWMANAGER="wm-ng"
1777    else
1778      einfo "Window manager ${WHITE}${WINDOWMANAGER}${NORMAL} found as bootoption." && eend 0
1779    fi
1780    einfo "Setting up and invoking grml-x ${WINDOWMANAGER}. Just exit X windows system to get full featured consoles."
1781    config_userfstab || fstabuser='grml'
1782  cat>|/etc/init.d/xstartup<<EOF
1783 #!/bin/sh
1784 su $fstabuser -c "/usr/bin/grml-x $WINDOWMANAGER"
1785 EOF
1786    chmod 755 /etc/init.d/xstartup
1787
1788    # adjust inittab for xstartup
1789    if grep -q '^6:' /etc/inittab ; then
1790       sed -i 's|^6:.*|6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /usr/bin/zsh-login" >/dev/tty6 2>\&1 </dev/tty6|' /etc/inittab
1791    else # just append tty6 to inittab if no definition is present:
1792       echo '6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /usr/bin/zsh-login" >/dev/tty6 2>&1 < /dev/tty6' >> /etc/inittab
1793    fi
1794
1795    /sbin/telinit q ; eend $?
1796
1797    if grep -q '^allowed_users=' /etc/X11/Xwrapper.config ; then
1798       sed -i 's/^allowed_users=.*/allowed_users=anybody/' /etc/X11/Xwrapper.config
1799    else
1800       echo 'allowed_users=anybody' >> /etc/X11/Xwrapper.config
1801    fi
1802
1803   else
1804     eerror "We are not running in live mode - startx will not work, skipping it."
1805     eerror " -> Please use something like xdm, gdm or kdm for starting X on a harddisk system!" ; eend 1
1806   fi
1807  else
1808    eerror "/usr/X11R6/bin/X is not present on this grml flavour."
1809    eerror "  -> Boot parameter startx does not work therefore." ; eend 1
1810  fi
1811 fi
1812 }
1813 # }}}
1814
1815 # {{{ configuration framework
1816 config_extract(){
1817 if checkbootparam 'extract' ; then
1818  EXTRACT="$(getbootparam 'extract' 2>>$DEBUG)"
1819  EXTRACTOPTIONS="-- -x $EXTRACT"
1820 fi
1821 }
1822
1823 config_finddcsdir() {
1824 #  - If no GRMLCFG partition is found and noautoconfig is _not_ given
1825 #    on the command line, nothing is changed and the dcs files are
1826 #    searched within the .iso, $dcs-dir is set to the root directory
1827 #    within the .iso
1828 #  - If a GRMLCFG partition is found, $dcs-dir is set to the root of
1829 #    the GRMLCFG partition unless noautoconfig is set. If noautoconfig is
1830 #    set, $dcs-dir is set to the root directory within the .iso.
1831 #  - If myconfig=foo is set on the command line, $dcs-dir is set to
1832 #    foo, even if a GRMLCFG partition is present.
1833 DCSDIR=""
1834 DCSMP="/mnt/grml"
1835 if checkbootparam 'noautoconfig' || checkbootparam 'forensic' ; then
1836   ewarn "Skipping running automount of device(s) labeled GRMLCFG as requested." ; eend 0
1837 else
1838   if [ -z "$INSTALLED" ] ; then
1839     if checkbootparam 'myconfig' ; then
1840       DCSDEVICE="$(getbootparam 'myconfig' 2>>$DEBUG)"
1841       if [ -z "$DCSDEVICE" ]; then
1842         eerror "Error: No device for bootoption myconfig provided." ; eend 1
1843       fi # [ -z "$DCSDEVICE" ]
1844     elif checkvalue $CONFIG_MYCONFIG; then # checkbootparam myconfig
1845       einfo "Searching for device(s) labeled with GRMLCFG. (Disable this via boot option: noautoconfig)" ; eend 0
1846       eindent
1847       # We do need the following fix so floppy disk is available to blkid in any case :-/
1848       if [ -r /dev/fd0 ] ; then
1849         einfo "Floppy device detected. Trying to access floppy disk."
1850         if timeout 4 dd if=/dev/fd0 of=/dev/null bs=512 count=1 >>$DEBUG 2>&1 ; then
1851            blkid /dev/fd0 >>$DEBUG 2>&1
1852         fi
1853       fi
1854       DCSDEVICE=$(blkid -t LABEL=GRMLCFG | head -1 | awk -F: '{print $1}')
1855       if [ -n "$DCSDEVICE" ]; then
1856         DCSMP="/mnt/grmlcfg"
1857       fi
1858       eoutdent
1859     fi
1860
1861     # if not specified/present then assume default:
1862     if [ -z "$DCSDEVICE" ]; then
1863       DCSDIR="/live/image"
1864     else
1865       eindent
1866       einfo "debs, config, scripts are read from $DCSDEVICE." ; eend 0
1867       DCSDIR="$(< /proc/mounts awk -v DCSDEV=$DCSDEVICE '{if ($1 == DCSDEV) { print $2 }}')"
1868       if [ -n "$DCSDIR" ]; then
1869         ewarn "$DCSDEVICE already mounted on $DCSDIR"; eend 0
1870       else
1871         [ -d $DCSMP ] || mkdir $DCSMP
1872         umount $DCSMP >>$DEBUG 2>&1 # make sure it is not mounted
1873         mount -o ro -t auto $DCSDEVICE  $DCSMP ; RC="$?"
1874         if [[ $RC == 0 ]]; then
1875           einfo "Successfully mounted $DCSDEVICE to $DCSMP (readonly)." ; eend 0
1876         else
1877           eerror "Error: mounting $DCSDEVICE to $DCSMP (readonly) failed." ; eend 1
1878         fi
1879         DCSDIR="$DCSMP"
1880       fi
1881       eoutdent
1882     fi
1883   fi
1884 fi
1885
1886 if [ -n "$DCSDIR" -a "$DCSDIR" != "/live/image" ] ; then
1887   einfo "Debs, config, scripts (if present) will be read from $DCSDIR." ; eend 0
1888 elif checkbootparam 'debs' || checkbootparam 'config' || checkbootparam 'scripts'; then
1889   einfo "Debs, config, scripts will be read from the live image directly." ; eend 0
1890 fi
1891 }
1892
1893
1894 config_partconf() {
1895 if checkbootparam 'partconf' ; then
1896  MOUNTDEVICE="$(getbootparam 'partconf' 2>>$DEBUG)"
1897  if [ -n "$MOUNTDEVICE" ]; then
1898    [ -d /mnt/grml ] || mkdir /mnt/grml
1899    mount -o ro -t auto $MOUNTDEVICE /mnt/grml ; RC="$?"
1900     if [[ $RC == 0 ]]; then
1901       einfo "Successfully mounted $MOUNTDEVICE to /mnt/grml (readonly)." ; eend 0
1902       einfo "Copying files from $MOUNTDEVICE over grml system."
1903       for file in `cat /etc/grml/partconf` ; do
1904         [ -d /mnt/grml/$file ] && cp -a /mnt/grml/${file}* ${file} && echo "copied: $file"
1905         [ -f /mnt/grml/$file ] && cp -a /mnt/grml/${file}  ${file} && echo "copied: $file"
1906       done && eend 0
1907     else
1908       einfo "Could not mount $MOUNTDEVICE to /mnt/grml - sorry." ; eend 1
1909     fi # mount $MOUNTDEVICE
1910    grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1911  else
1912    einfo "Sorry, no device for bootoption partconf provided. Skipping." ; eend 1
1913  fi # [ -n "$MOUNTDEVICE" ]
1914 fi
1915 }
1916 # }}}
1917
1918 # {{{ /cdrom/.*-options
1919 config_debs(){
1920 if checkbootparam 'debs' ; then
1921    iszsh && setopt localoptions shwordsplit
1922    DEBS="$(getbootparam 'debs' 2>>$DEBUG)"
1923    if ! echo $DEBS | grep -q '/'; then
1924      # backwards compatibility: if no path is given get debs from debs/
1925      DEBS="debs/$DEBS"
1926    fi
1927    einfo "Tring to install debian package(s) ${DEBS}"
1928    DEBS="$(eval echo ${DCSDIR}/$DEBS)"
1929    dpkg -i $DEBS ; eend $?
1930 fi
1931 }
1932
1933 config_scripts(){
1934 if checkbootparam 'scripts' || [ "$DCSMP" = "/mnt/grmlcfg" ]; then
1935    SCRIPTS="$(getbootparam 'scripts' 2>>$DEBUG)"
1936    if [ -d ${DCSDIR}/scripts ] && [ -z "$SCRIPTS" ]; then
1937      SCRIPTS="$(cd ${DCSDIR}/scripts; /bin/ls -1d [Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1938    fi
1939    if ! echo $SCRIPTS | grep -q '/'; then
1940      # backwards compatibility: if no path is given get scripts from scripts/
1941      SCRIPTS="scripts/$SCRIPTS"
1942    fi
1943    if [ "$DCSMP" = "/mnt/grmlcfg" ]; then
1944      # we are executing from a GRMLCFG labeled fs
1945      # kick everything we have done before and start over
1946      SCRIPTS="$(cd ${DCSDIR}; /bin/ls -1d [Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1947    fi
1948    if [ -n "$SCRIPTS" ]; then
1949      SCRIPTS="${DCSDIR}/$SCRIPTS"
1950      if [ "$DCSMP" = "/mnt/grmlcfg" ]; then
1951        einfo "Trying to execute ${SCRIPTS}"
1952        sh -c $SCRIPTS
1953      elif [ -d "$SCRIPTS" ]; then
1954        einfo "Bootparameter scripts found. Trying to execute from directory ${SCRIPTS}:"
1955        run-parts $SCRIPTS
1956      else
1957        einfo "Bootparameter scripts found. Trying to execute ${SCRIPTS}:"
1958        sh -c $SCRIPTS
1959      fi
1960    fi
1961 fi
1962 }
1963
1964 config_config(){
1965 if checkbootparam 'config' || [ "$DCSMP" = "/mnt/grmlcfg" ]; then
1966   CONFIG="$(getbootparam 'config' 2>>$DEBUG)"
1967   if [ -z "$CONFIG" ]; then
1968     CONFIG="$(cd ${DCSDIR}; ls -1d [Cc][Oo][Nn][Ff][Ii][Gg].[Tt][Bb][Zz] 2>>$DEBUG)"
1969   fi
1970   if [ -n "$CONFIG" ]; then
1971     if [ -d "${DCSDIR}/${CONFIG}" ] ; then
1972       einfo "Taking configuration from directory ${DCSDIR}/${CONFIG}"
1973
1974       cp -a ${DCSDIR}/${CONFIG}/* /
1975     elif [ -f "${DCSDIR}/${CONFIG}" ]; then
1976       einfo "Extracting configuration from file ${DCSDIR}/${CONFIG}"
1977
1978       cd /
1979       unp ${DCSDIR}/${CONFIG} $EXTRACTOPTIONS ; eend $?
1980     else
1981       ewarn "Sorry, could not find configuration file or directory ${DCSDIR}/${FILENAME}." ; eend 1
1982     fi
1983   fi
1984 fi
1985 # umount $DCSMP if it was mounted by finddcsdir
1986 # this doesn't really belong here
1987 grep -q '$DCSMP' /proc/mounts && umount $DCSMP
1988 }
1989 # }}}
1990
1991 # {{{ mypath
1992 config_mypath(){
1993 if checkbootparam 'mypath' ; then
1994    MY_PATH="$(getbootparam 'mypath' 2>>$DEBUG)"
1995    einfo "Bootparameter mypath found, adding ${MY_PATH} to /etc/grml/my_path"
1996    touch /etc/grml/my_path
1997    chmod 644 /etc/grml/my_path
1998    # make sure the directories exist:
1999    eindent
2000    for i in $(echo $MY_PATH | sed 's/:/\n/g') ; do
2001        if ! [ -d "$i" ] ; then
2002           einfo "Creating directory $i"
2003           mkdir -p "$i" ; eend $?
2004        fi
2005    done
2006    grep -q "${MY_PATH}" /etc/grml/my_path || echo "${MY_PATH}" >> /etc/grml/my_path ; eend $?
2007    eoutdent
2008 fi
2009 }
2010 # }}}
2011
2012 # {{{ distcc
2013 config_distcc(){
2014 if checkbootparam 'distcc' ; then
2015  OPTIONS="$(getbootparam 'distcc' 2>>$DEBUG)"
2016  if [ -n "$OPTIONS" ]; then
2017     NET=""
2018     INTERFACE=""
2019     if [ -n "$OPTIONS" ]; then
2020       NET="${OPTIONS%%,*}"
2021       R="${OPTIONS#*,}"
2022       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
2023         OPTIONS="$R"
2024         INTERFACE="${OPTIONS%%,*}"
2025         R="${OPTIONS#*,}"
2026       fi
2027     fi
2028  fi
2029  CONFIG=/etc/default/distcc
2030  sed -i "s#^STARTDISTCC=.*#STARTDISTCC=YES#"  $CONFIG
2031  sed -i "s#^ALLOWEDNETS=.*#ALLOWEDNETS=$NET#" $CONFIG
2032
2033  if [ -n "$INTERFACE" ] ; then
2034    IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
2035
2036    counter=10
2037    while [ -z "$IP" ] && [[ "$counter" != 0 ]] ; do
2038      counter=$(( counter-1 ))
2039      ewarn "No ip address for $INTERFACE found. Sleeping for 3 seconds. $counter tries left."
2040      sleep 3
2041      IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
2042    done
2043  fi
2044
2045  if [ -n "$IP" ] ; then
2046    sed -i "s#^LISTENER=.*#LISTENER=$IP#"      $CONFIG
2047
2048    einfo "Bootoption distcc found. Preparing setup for distcc daemon."
2049    eindent
2050     id distccd >/dev/null 2>&1 || \
2051     (
2052       einfo "Creating distcc user" ; \
2053       adduser --quiet --system --ingroup nogroup --home / --no-create-home distccd ; eend $?
2054     )
2055
2056     einfo "Starting distcc for network ${NET}, listening on ${IP}."
2057    /etc/init.d/distcc start >/dev/null ; eend $?
2058    eoutdent
2059  else
2060    eerror "No ip address for $INTERFACE found. distcc can not be used without it." ; eend 1
2061  fi
2062 fi
2063
2064 if checkbootparam 'gcc'; then
2065  GCC="$(getbootparam 'gcc' 2>>$DEBUG)"
2066  eindent
2067  einfo "Pointing /usr/bin/gcc to /usr/bin/gcc-${GCC}."
2068  eoutdent
2069  rm -f /usr/bin/gcc
2070  ln -s /usr/bin/gcc-${GCC} /usr/bin/gcc ; eend $?
2071 fi
2072
2073 if checkbootparam 'gpp'; then
2074  GPP="$(getbootparam 'gpp' 2>>$DEBUG)"
2075  eindent
2076   einfo "Pointing /usr/bin/g++ to /usr/bin/g++-${GPP}."
2077   if [ -x /usr/bin/g++-${GPP} ] ; then
2078      rm -f /usr/bin/g++
2079      ln -s /usr/bin/g++-${GPP} /usr/bin/g++ ; eend $?
2080   fi
2081   einfo "Pointing /usr/bin/cpp to /usr/bin/cpp-${GPP}."
2082   if [ -x /usr/bin/cpp-${GPP} ] ; then
2083      rm -f /usr/bin/cpp
2084      ln -s /usr/bin/cpp-${GPP} /usr/bin/cpp ; eend $?
2085   fi
2086  eoutdent
2087 fi
2088
2089 }
2090 # }}}
2091
2092 # {{{ load modules
2093 # Notice: use it only on live-cd system, if running from harddisk please
2094 # add modules to /etc/modules and activate /etc/init.d/module-init-tools
2095 # in /etc/runlevel.conf
2096 config_modules(){
2097 MODULES_FILE=/etc/grml/modules
2098 if checkbootparam 'nomodules' ; then
2099   ewarn "Skipping loading of modules defined in ${MODULES_FILE} as requested." ; eend 0
2100 elif [ -z "$INSTALLED" ]; then
2101  if [ -r $MODULES_FILE ] ; then
2102   einfo "Loading modules specified in ${MODULES_FILE}:"
2103   eindent
2104   grep '^[^#]' $MODULES_FILE | \
2105   while read module args; do
2106     [ "$module" ] || continue
2107       einfo "${module}"
2108       modprobe $module $args ; eend $?
2109   done
2110   eoutdent
2111  else
2112   ewarn "File $MODULES_FILE does not exist. Skipping loading of specific modules." ; eend 1
2113  fi
2114 fi
2115 }
2116 # }}}
2117
2118 # {{{ 915resolution
2119 config_915resolution(){
2120 if checkbootparam '915resolution' ; then
2121  OPTIONS="$(getbootparam '915resolution' 2>>$DEBUG)"
2122   if [ -x /usr/sbin/915resolution ]; then
2123     CMD=915resolution
2124     MODE=""
2125     XRESO=""
2126     YRESO=""
2127     if [ -n "$OPTIONS" ]; then
2128       # Extra options
2129       MODE="${OPTIONS%%,*}"
2130       R="${OPTIONS#*,}"
2131       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
2132         OPTIONS="$R"
2133         XRESO="${OPTIONS%%,*}"
2134         R="${OPTIONS#*,}"
2135         if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
2136           OPTIONS="$R"
2137           YRESO="${OPTIONS%%,*}"
2138           R="${OPTIONS#*,}"
2139         fi
2140       fi
2141     fi
2142     einfo "Running 915resolution with options ${MODE} ${XRESO} ${YRESO}."
2143     [ -n "$MODE" ] && [ -n "$XRESO"  ] && [ -n "$YRESO" ]  && ( sh -c "$CMD $MODE $XRESO $YRESO" & )
2144     eend 0
2145   fi
2146 fi
2147 }
2148 # }}}
2149
2150 # {{{ SW-RAID
2151 config_swraid(){
2152   [ -n "$INSTALLED" ] && return 0
2153
2154   # notice: checkbootparam "forensic" is just for users who don't know how to really use the bootoption
2155   if checkbootparam 'noraid'   || checkbootparam 'noswraid' || \
2156      checkbootparam 'forensic' || checkbootparam 'raid=noautodetect' ; then
2157      ewarn "Skipping SW-RAID code as requested on boot commandline." ; eend 0
2158   else
2159     if ! [ -x /sbin/mdadm ] ; then
2160        eerror "mdadm not available, can not execute it." ; eend 1
2161     else
2162
2163        # if ! egrep -qv '^(MAILADDR.*|#.*|)$' /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
2164        # find out whether we have a valid configuration file already
2165        if ! grep -q ARRAY /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
2166           einfo "Creating /etc/mdadm/mdadm.conf for use with mdadm."
2167           [ -r /etc/mdadm/mdadm.conf ] && mv /etc/mdadm/mdadm.conf /etc/mdadm/mdadm.conf.old
2168           MDADM_MAILADDR__='root' /usr/share/mdadm/mkconf > /etc/mdadm/mdadm.conf ; eend $?
2169         else
2170           ewarn "/etc/mdadm/mdadm.conf looks like a configured mdadm setup, will not touch it." ; eend 0
2171        fi
2172
2173        if ! checkbootparam 'swraid' ; then
2174           eindent
2175           einfo "Just run 'Start mdadm-raid' to assemble md arrays or boot using 'swraid' as bootoption for autostart."
2176           eoutdent
2177        else
2178           einfo "Bootoption swraid found. Searching for software RAID arrays:"
2179           eindent
2180            IFSOLD=${IFS:-}
2181            IFS='
2182 '
2183            for line in $(mdadm --assemble --scan --auto=yes --symlink=no 2>&1) ; do
2184                case $line in
2185                  *'No arrays found'*)
2186                    ewarn "$line" ; eend 0
2187                    ;;
2188                  *)
2189                    einfo "$line" ; eend 0
2190                    ;;
2191                esac
2192            done
2193            IFS=$IFSOLD
2194          eoutdent
2195
2196          if [ -r /proc/mdstat ] ; then
2197             eindent
2198             MDSTAT=$(grep '^md[0-9]' /proc/mdstat)
2199             if [ -z "$MDSTAT" ] ; then
2200                ewarn "No active arrays found" ; eend 0
2201             else
2202                IFSOLD=${IFS:-}
2203                IFS='
2204 '
2205                for line in $(grep '^md[0-9]' /proc/mdstat) ; do
2206                    einfo "active arrays: $line" ; eend 0
2207                done
2208                IFS=$IFSOLD
2209             fi
2210             eoutdent
2211          fi # /proc/mdstat
2212        fi # bootoption swraid
2213
2214      fi # is /sbin/mdadm executable?
2215   fi # check for bootoptions
2216 }
2217 # }}}
2218
2219 # {{{ dmraid
2220 config_dmraid(){
2221   [ -n "$INSTALLED" ] && return 0
2222
2223   if checkbootparam 'nodmraid' ; then
2224     ewarn "Skipping dmraid code as requested on boot commandline." ; eend 0
2225     return 0
2226   fi
2227
2228   if ! [ -x /sbin/dmraid ] ; then
2229     eerror "dmraid not available, can not execute it." ; eend 1
2230     return
2231   fi
2232
2233   dmraid_wrapper() {
2234     # usage: dmraid_wrapper <dmraid_option>
2235     [ -n "$1" ] || return 1
2236
2237     IFSOLD=${IFS:-}
2238     IFS='
2239 '
2240     eindent
2241
2242     for line in $(dmraid $1 ; echo errcode:$?); do
2243       case $line in
2244         *'no block devices found'*)
2245           einfo "No block devices found" ; eend 0
2246           break
2247           ;;
2248         *'no raid disks'*)
2249           einfo "No active dmraid devices found" ; eend 0
2250           break
2251           ;;
2252         errcode:0)
2253           eend 0;
2254           ;;
2255         errcode:1)
2256           eend 1
2257           ;;
2258         *)
2259           einfo "$line"
2260           ;;
2261       esac
2262     done
2263
2264     eoutdent
2265     IFS=$IFSOLD
2266   }
2267
2268   if checkbootparam 'dmraid' ; then
2269     local ACTION="$(getbootparam 'dmraid' 2>>$DEBUG)"
2270     if [ "$ACTION" = "off" ] ; then
2271       # Deactivates all active software RAID sets:
2272       einfo "Deactivating present dmraid sets (as requested via dmraid=off):"
2273       dmraid_wrapper -an
2274     else
2275       # Activate all software RAID sets discovered:
2276       einfo "Activating present dmraid sets (as requested via dmraid):"
2277       dmraid_wrapper -ay
2278     fi
2279
2280     return
2281   fi
2282
2283   # by default (no special bootoptions) discover all software RAID devices:
2284   einfo "Searching for any present dmraid sets:"
2285   dmraid_wrapper -r
2286 }
2287 # }}}
2288
2289 # {{{ LVM (Logical Volumes)
2290 config_lvm(){
2291   [ -n "$INSTALLED" ] && return 0
2292
2293   if checkbootparam 'nolvm' ; then
2294      ewarn "Skipping LVM code as requested on boot commandline." ; eend 0
2295   else
2296     # Debian etch provides /etc/init.d/lvm only, newer suites provide /etc/init.d/lvm2
2297     if ! [ -x /sbin/lvm -a -x /sbin/lvdisplay ] || ! [ -x /etc/init.d/lvm2 -o -x /etc/init.d/lvm ] ; then
2298        eerror "LVM not available, can not execute it." ; eend 1
2299     else
2300        if lvdisplay 2>&1 | grep -v 'No volume groups found' >/dev/null 2>&1 ; then
2301           einfo "You seem to have logical volumes (LVM) on your system."
2302           eindent
2303           einfo "Just run 'Start lvm2' to activate them or boot using 'lvm' as bootoption for autostart."
2304           eend 0
2305           if checkbootparam 'lvm' ; then
2306              einfo "Bootoption LVM found. Searching for logical volumes:"
2307              /etc/init.d/lvm2 start ; eend $?
2308           fi
2309           eoutdent
2310        fi
2311     fi # check for lvm binary
2312   fi # check for bootoption nolvm
2313 }
2314 # }}}
2315
2316 # {{{ debnet: setup network based on an existing one found on a partition
2317 config_debnet(){
2318 if checkbootparam 'debnet' ; then
2319  einfo "Bootoption 'debnet' found. Searching for Debian network configuration: "
2320  /usr/sbin/debnet
2321 fi
2322 }
2323 # }}}
2324
2325 # {{{ disable console blanking
2326 config_blanking(){
2327 if checkbootparam 'noblank' ; then
2328   einfo "Bootoption noblank found. Disabling monitor blanking."
2329   setterm -blank 0 ; eend $?
2330 fi
2331 }
2332 # }}}
2333
2334 # {{{ tohd= bootoption
2335 config_tohd()
2336 {
2337   if checkbootparam 'tohd' ; then
2338      local TARGET="$(getbootparam 'tohd' 2>>$DEBUG)"
2339      if [ -z "$TARGET" ] ; then
2340         eerror "Error: tohd specified without any partition, can not continue." ; eend 1
2341         eerror "Please use something like tohd=/dev/sda9." ; eend 1
2342         return 1
2343      fi
2344
2345      if ! [ -b "$TARGET" ] ; then
2346         eerror "Error: $TARGET is not a valid block device, sorry." ; eend 1
2347         return 1
2348      fi
2349
2350      if grep -q $TARGET /proc/mounts ; then
2351         eerror "$TARGET already mounted, skipping execution of tohd therefore."
2352         eend 1
2353         return 1
2354      fi
2355
2356      local MOUNTDIR=$(mktemp -d)
2357
2358      if mount -o rw "$TARGET" "$MOUNTDIR" ; then
2359         einfo "Copyring live system to $TARGET - this might take a while"
2360         rsync -a --progress /live/image/live $MOUNTDIR
2361         sync
2362         umount "$MOUNTDIR"
2363         eend $?
2364         einfo "Booting with \"grml bootfrom=$TARGET\" should work now." ; eend 0
2365      else
2366         eerror "Error when trying to mount $TARGET, sorry."; eend 1
2367         return 1
2368      fi
2369
2370      rmdir "$MOUNTDIR"
2371   fi
2372 }
2373 # }}}
2374
2375 # {{{ grml2hd: automatic installation
2376 config_grml2hd(){
2377
2378 if checkbootparam "BOOT_IMAGE=grml2hd" ; then
2379
2380 if checkbootparam 'user' ; then
2381    NEWUSER=''
2382    NEWUSER="$(getbootparam 'user' 2>>$DEBUG)"
2383    sed -i "s/^NEWUSER=.*/NEWUSER=$NEWUSER/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2384 fi
2385
2386 if checkbootparam 'filesystem' ; then
2387    FILESYSTEM=''
2388    FILESYSTEM="$(getbootparam 'filesystem' 2>>$DEBUG)"
2389    sed -i "s/^FILESYSTEM=.*/FILESYSTEM=$FILESYSTEM/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2390 fi
2391
2392 if checkbootparam 'partition' ; then
2393    PARTITION=''
2394    PARTITION="$(getbootparam 'partition' 2>>$DEBUG)"
2395    # notice: the following checks whether the given partition is available, if not the skip
2396    # execution of grml2hd as it might result in data loss...
2397    if [ -r $PARTITION ] ; then
2398       sed -i "s#^PARTITION=.*#PARTITION=$PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2399    else
2400       ewarn "Partition $PARTITION does not exist. Skipping execution of grml2hd therefore." ; eend 1
2401    fi
2402 fi
2403
2404 if checkbootparam 'mbr' ; then
2405    BOOT_PARTITION=''
2406    BOOT_PARTITION="$(getbootparam 'mbr' 2>>$DEBUG)"
2407    sed -i "s#^BOOT_PARTITION=.*#BOOT_PARTITION=$BOOT_PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2408 fi
2409
2410 cat>|/usr/bin/grml2hd_noninteractive<<EOF
2411 #!/bin/sh
2412 GRML2HD_NONINTERACTIVE='yes' grml2hd
2413 EOF
2414
2415 chmod 755 /usr/bin/grml2hd_noninteractive
2416 einfo "Bootoption grml2hd found. Running automatic installation via grml2hd using /etc/grml2hd/config." && eend 0
2417 if [ -z "$GRML2HD_FAIL" ] ; then
2418    screen /usr/bin/grml2hd_noninteractive ; einfo "Invoking a shell, just exit to continue booting..." ; /bin/zsh
2419 else
2420    ewarn "There was an error adjusting /etc/grml2hd/config. Skipping execution of grml2hd for security reasons." ; eend 1
2421 fi
2422
2423 fi # if checkbootparam "BOOT_IMAGE=grml2hd ...
2424 }
2425 # }}}
2426
2427 # {{{ debootstrap: automatic installation
2428 config_debootstrap(){
2429
2430 if checkbootparam "BOOT_IMAGE=debian2hd" ; then
2431
2432 einfo "Bootoption debian2hd found. Setting up environment for automatic installation via grml-debootstrap." ; eend 0
2433
2434 if ! [ -x /usr/sbin/grml-debootstrap ] ; then
2435    eindent
2436    eerror "Bootoption debian2hd found, but grml-debootstrap is not available." ; eend 1
2437    eoutdent
2438    exit 1
2439 fi
2440
2441 if checkbootparam 'target' ; then
2442   TARGET=''
2443   TARGET="$(getbootparam 'target' 2>>$DEBUG)"
2444   # notice: the following checks whether the given partition is available, if not the skip
2445   # execution of grml-debootstrap as it might result in data loss...
2446   if ! [ -r "$TARGET" ] ; then
2447      eerror "Target $TARGET does not exist. Skipping execution of grml-debootstrap therefore." ; eend 1
2448   fi
2449 else
2450   eindent
2451   eerror "No bootoption named target found, can not continue execution of grml-debootstrap." ; eend 1
2452   eoutdent
2453   exit 1
2454 fi
2455
2456 if checkbootparam 'grub' ; then
2457   GRUB=''
2458   GRUB="$(getbootparam 'grub' 2>>$DEBUG)"
2459 fi
2460
2461 if checkbootparam 'groot' ; then
2462   GROOT=''
2463   GROOT="$(getbootparam 'groot' 2>>$DEBUG)"
2464 fi
2465
2466 if checkbootparam 'release' ; then
2467   RELEASE=''
2468   RELEASE="$(getbootparam 'release' 2>>$DEBUG)"
2469 fi
2470
2471 if checkbootparam 'mirror' ; then
2472   MIRROR=''
2473   MIRROR="$(getbootparam 'mirror' 2>>$DEBUG)"
2474 fi
2475
2476 if checkbootparam 'boot_append' ; then
2477   BOOT_APPEND=''
2478   BOOT_APPEND="$(getbootparam 'boot_append' 2>>$DEBUG)"
2479 fi
2480
2481 if checkbootparam 'password' ; then
2482   PASSWORD=''
2483   PASSWORD="$(getbootparam 'password' 2>>$DEBUG)"
2484 fi
2485
2486 # now check which options are available
2487 if [ -n "TARGET" ] ; then
2488    TARGETCMD="--target $TARGET"
2489 else
2490    TARGETCMD=''
2491    eindent
2492    eerror "Target not set via bootoption. Skipping execution of grml-debootstrap therefore."; eend 1
2493    eoutdent
2494    exit 1
2495 fi
2496 [ -n "$GRUB" ]     && GRUBCMD="--grub $GRUB"               || GRUBCMD=''
2497 [ -n "$GROOT" ]    && GROOTCMD="--groot $GROOT"            || GROOTCMD=''
2498 [ -n "$RELEASE" ]  && RELEASECMD="--release $RELEASE"      || RELEASECMD=''
2499 [ -n "$MIRROR" ]   && MIRRORCMD="--mirror $MIRROR"         || MIRRORCMD=''
2500 [ -n "$PASSWORD" ] && PASSWORDCMD="--password $PASSWORD"   || PASSWORDCMD=''
2501 [ -n "$BOOT_APPEND" ] && BOOT_APPEND="--boot_append $BOOT_APPEND" || BOOT_APPEND=''
2502
2503 # and finally write script and execute it
2504 cat>|/usr/bin/grml-debootstrap_noninteractive<<EOF
2505 #!/bin/sh
2506 AUTOINSTALL='yes' grml-debootstrap $TARGETCMD $GRUBCMD $GROOTCMD $RELEASECMD $MIRRORCMD $PASSWORDCMD $BOOT_APPEND
2507 EOF
2508
2509 chmod 750  /usr/bin/grml-debootstrap_noninteractive
2510
2511 screen /usr/bin/grml-debootstrap_noninteractive
2512 einfo "Invoking a shell, just exit to continue booting..."
2513 /bin/zsh
2514
2515 fi # checkbootparam "BOOT_IMAGE=debian2hd
2516 }
2517 # }}}
2518
2519 # {{{ Support customization
2520 config_distri(){
2521 if checkbootparam 'distri'; then
2522   DISTRI="$(getbootparam 'distri' 2>>$DEBUG)"
2523   if [ -r "${LIVECD_PATH}"/desktop/"$DISTRI".jpg ] ; then
2524      [ -n "$BOOTDEBUG" ] && einfo "Debug: bootoption distri found and file ${LIVECD_PATH}/desktop/${DISTRI} present" && eend 0
2525      # make sure the desktop.jpg file is not a symlink, so copying does not file then
2526      [ -L /usr/share/grml/desktop.jpg ] && rm /usr/share/grml/desktop.jpg
2527      cp "${LIVECD_PATH}"/desktop/"$DISTRI".jpg /usr/share/grml/desktop.jpg
2528   fi
2529 fi
2530 }
2531 # }}}
2532
2533 ## END OF FILE #################################################################
2534 # vim:foldmethod=marker expandtab ai ft=zsh shiftwidth=3